package ru.microem.reader.usb_bluetooth_test.ui.icode;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.TextView;

import androidx.annotation.Nullable;
import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProviders;
import ru.microem.reader.usb_bluetooth_test.MainActivity;
import ru.microem.reader.usb_bluetooth_test.R;
import ru.microem.readerlibrary.UemReader;

public class ICodeFragment extends Fragment {

    private ICodeViewModel iCodeViewModel;

    private View mRoot = null;

    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        iCodeViewModel =
                ViewModelProviders.of(this).get(ICodeViewModel.class);
        View root = inflater.inflate(R.layout.fragment_icode, container, false);
        final TextView textView = root.findViewById(R.id.text_icode);
        iCodeViewModel.getText().observe(this, new Observer<String>() {
            @Override
            public void onChanged(@Nullable String s) {
                textView.setText(s);
            }
        });

        mRoot = root;

        ((MainActivity)getActivity()).mICodeFragment = this;

        SharedPreferences sharedPref = getActivity().getPreferences(Context.MODE_PRIVATE);
        ((EditText)root.findViewById(R.id.ic_block)).setText(sharedPref.getString("ic_block", "10"));
        ((EditText)root.findViewById(R.id.ic_data)).setText(sharedPref.getString("ic_data", "00000000"));
        ((TextView)root.findViewById(R.id.ic_log)).setText(sharedPref.getString("ic_log", ""));

        return root;
    }

    public void onPause() {
        SharedPreferences sharedPref = getActivity().getPreferences(Context.MODE_PRIVATE);
        sharedPref.edit().putString("ic_block", ((EditText)mRoot.findViewById(R.id.ic_block)).getText().toString()).apply();
        sharedPref.edit().putString("ic_data", ((EditText)mRoot.findViewById(R.id.ic_data)).getText().toString()).apply();
        sharedPref.edit().putString("ic_log", ((TextView)mRoot.findViewById(R.id.ic_log)).getText().toString()).apply();

        super.onPause();
    }

    public void onICodeCommand(View view) {
        EditText editBlock = mRoot.findViewById(R.id.ic_block);
        int blockNum = Integer.parseInt(editBlock.getText().toString());
        EditText editData = mRoot.findViewById(R.id.ic_data);
        byte[] data = UemReader.Helper.hexStringToByteArray(editData.getText().toString());
        TextView log = mRoot.findViewById(R.id.ic_log);
        switch(view.getId()) {
            case R.id.ic_read:
                UemReader.CommandsCards.CommandsISO15693.BlockISO15693 block = ((MainActivity) getActivity()).mUemR.Cards.ISO15693.readSingleBlock(blockNum);
                ((MainActivity) getActivity()).appendLog(log, "Read Block", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                        ), ((MainActivity) getActivity()).mUemR.getLastError().equals(UemReader.UEM_STATUS_SUCCESS)?String.format("Data: %s",
                        UemReader.Helper.byteArrayToHexString(block.data)
                        ):null
                );
                break;
            case R.id.ic_write:
                ((MainActivity) getActivity()).mUemR.Cards.ISO15693.writeSingleBlock(blockNum, data);
                ((MainActivity) getActivity()).appendLog(log, "Write Block", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));
                break;
            default:
        }
    }
}