package ru.microem.reader.usb_bluetooth_test.ui.mifare_plus;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProviders;
import ru.microem.reader.usb_bluetooth_test.MainActivity;
import ru.microem.reader.usb_bluetooth_test.R;
import ru.microem.readerlibrary.UemReader;

public class MifarePlusFragment extends Fragment {

    private MifarePlusViewModel mifarePlusViewModel;

    private View mRoot = null;

    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        mifarePlusViewModel =
                ViewModelProviders.of(this).get(MifarePlusViewModel.class);
        View root = inflater.inflate(R.layout.fragment_mifare_plus, container, false);
        final TextView textView = root.findViewById(R.id.text_mifare_plus);
        mifarePlusViewModel.getText().observe(this, new Observer<String>() {
            @Override
            public void onChanged(@Nullable String s) {
                textView.setText(s);
            }
        });

        mRoot = root;

        ((MainActivity)getActivity()).mMifarePlusFragment = this;

        SharedPreferences sharedPref = getActivity().getPreferences(Context.MODE_PRIVATE);
        ((EditText)root.findViewById(R.id.mfp_edit_flash_address)).setText(sharedPref.getString("mfp_edit_flash_address", "0"));
        ((CheckBox)root.findViewById(R.id.mfp_check_use_sam)).setChecked(sharedPref.getBoolean("mfp_check_use_sam", false));
        ((EditText)root.findViewById(R.id.mfp_edit_sam_key_number)).setText(sharedPref.getString("mfp_edit_sam_key_number", "10"));
        ((EditText)root.findViewById(R.id.mfp_edit_sam_key_version)).setText(sharedPref.getString("mfp_edit_sam_key_version", "0"));
        ((EditText)root.findViewById(R.id.mfp_edit_sector)).setText(sharedPref.getString("mfp_edit_sector", "9"));
        ((Spinner)root.findViewById(R.id.mfp_spinner_key_type)).setSelection(sharedPref.getInt("mfp_spinner_key_type", 0));
        ((Spinner)root.findViewById(R.id.mfp_spinner_block_type)).setSelection(sharedPref.getInt("mfp_spinner_block_type", 0));
        ((EditText)root.findViewById(R.id.mfp_edit_block)).setText(sharedPref.getString("mfp_edit_block", "0"));
        ((EditText)root.findViewById(R.id.mfp_edit_blocks_count)).setText(sharedPref.getString("mfp_edit_blocks_count", "1"));
        ((EditText)root.findViewById(R.id.mfp_edit_data)).setText(sharedPref.getString("mfp_edit_data", "00000000000000000000000000000000"));
        ((CheckBox)root.findViewById(R.id.mfp_check_encrypt_cmd)).setChecked(sharedPref.getBoolean("mfp_check_encrypt_cmd", true));
        ((CheckBox)root.findViewById(R.id.mfp_check_mac_command)).setChecked(sharedPref.getBoolean("mfp_check_mac_command", true));
        ((CheckBox)root.findViewById(R.id.mfp_check_mac_response)).setChecked(sharedPref.getBoolean("mfp_check_mac_response", true));
        ((TextView)root.findViewById(R.id.mfp_log)).setText(sharedPref.getString("mfp_log", ""));

        return root;
    }

    public void onPause() {
        SharedPreferences sharedPref = getActivity().getPreferences(Context.MODE_PRIVATE);
        sharedPref.edit().putString("mfp_edit_flash_address", ((EditText)mRoot.findViewById(R.id.mfp_edit_flash_address)).getText().toString()).apply();
        sharedPref.edit().putBoolean("mfp_check_use_sam", ((CheckBox)mRoot.findViewById(R.id.mfp_check_use_sam)).isChecked()).apply();
        sharedPref.edit().putString("mfp_edit_sam_key_number", ((EditText)mRoot.findViewById(R.id.mfp_edit_sam_key_number)).getText().toString()).apply();
        sharedPref.edit().putString("mfp_edit_sam_key_version", ((EditText)mRoot.findViewById(R.id.mfp_edit_sam_key_version)).getText().toString()).apply();
        sharedPref.edit().putString("mfp_edit_sector", ((EditText)mRoot.findViewById(R.id.mfp_edit_sector)).getText().toString()).apply();
        sharedPref.edit().putInt("mfp_spinner_key_type", ((Spinner)mRoot.findViewById(R.id.mfp_spinner_key_type)).getSelectedItemPosition()).apply();
        sharedPref.edit().putInt("mfp_spinner_block_type", ((Spinner)mRoot.findViewById(R.id.mfp_spinner_block_type)).getSelectedItemPosition()).apply();
        sharedPref.edit().putString("mfp_edit_block", ((EditText)mRoot.findViewById(R.id.mfp_edit_block)).getText().toString()).apply();
        sharedPref.edit().putString("mfp_edit_blocks_count", ((EditText)mRoot.findViewById(R.id.mfp_edit_blocks_count)).getText().toString()).apply();
        sharedPref.edit().putString("mfp_edit_data", ((EditText)mRoot.findViewById(R.id.mfp_edit_data)).getText().toString()).apply();
        sharedPref.edit().putBoolean("mfp_check_encrypt_cmd", ((CheckBox)mRoot.findViewById(R.id.mfp_check_encrypt_cmd)).isChecked()).apply();
        sharedPref.edit().putBoolean("mfp_check_mac_command", ((CheckBox)mRoot.findViewById(R.id.mfp_check_mac_command)).isChecked()).apply();
        sharedPref.edit().putBoolean("mfp_check_mac_response", ((CheckBox)mRoot.findViewById(R.id.mfp_check_mac_response)).isChecked()).apply();
        sharedPref.edit().putString("mfp_log", ((TextView)mRoot.findViewById(R.id.mfp_log)).getText().toString()).apply();

        super.onPause();
    }

    public void onMfpCommand(View view) {
        EditText editFlashKeyAddress = mRoot.findViewById(R.id.mfp_edit_flash_address);
        int flashKey = Integer.parseInt(editFlashKeyAddress.getText().toString());
        CheckBox checkUseSAM = mRoot.findViewById(R.id.mfp_check_use_sam);
        boolean useSAM = checkUseSAM.isChecked();
        EditText editSAMKeyNo = mRoot.findViewById(R.id.mfp_edit_sam_key_number);
        int samKeyNo = Integer.parseInt(editSAMKeyNo.getText().toString());
        EditText editSAMKeyVer = mRoot.findViewById(R.id.mfp_edit_sam_key_version);
        int samKeyVer = Integer.parseInt(editSAMKeyVer.getText().toString());
        EditText editSector = mRoot.findViewById(R.id.mfp_edit_sector);
        int sector = Integer.parseInt(editSector.getText().toString());
        Spinner spinnerSecurityLevel = mRoot.findViewById(R.id.mfp_spinner_security_level);
        int securityLevel = spinnerSecurityLevel.getSelectedItemPosition();
        Spinner spinnerKeyType = mRoot.findViewById(R.id.mfp_spinner_key_type);
        int keyTypeIndex = (byte)spinnerKeyType.getSelectedItemPosition();
        Spinner spinnerBlockType = mRoot.findViewById(R.id.mfp_spinner_block_type);
        int blockTypeIndex = (byte)spinnerBlockType.getSelectedItemPosition();
        EditText editBlock = mRoot.findViewById(R.id.mfp_edit_block);
        int block = Integer.parseInt(editBlock.getText().toString());
        EditText editBlocksCount = mRoot.findViewById(R.id.mfp_edit_blocks_count);
        int blocksCount = Integer.parseInt(editBlocksCount.getText().toString());
        EditText editData = mRoot.findViewById(R.id.mfp_edit_data);
        byte[] data = UemReader.Helper.hexStringToByteArray(editData.getText().toString());
        CheckBox checkCommandMAC = mRoot.findViewById(R.id.mfp_check_mac_command);
        boolean useCommandMAC = checkCommandMAC.isChecked();
        CheckBox checkCommandEncryption = mRoot.findViewById(R.id.mfp_check_encrypt_cmd);
        boolean useCommandEncryption = checkCommandEncryption.isChecked();
        CheckBox checkResponseMAC = mRoot.findViewById(R.id.mfp_check_mac_response);
        boolean useResponseMAC = checkResponseMAC.isChecked();
        TextView log = mRoot.findViewById(R.id.mfp_log);

        int keyType = 0x00;

        switch (keyTypeIndex)
        {
            case 0:
                keyType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_AES_SECTOR_KEY_A;
                break;
            case 1:
                keyType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_AES_SECTOR_KEY_B;
                break;
            case 2:
                keyType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_ORIGINALITY_KEY;
                break;
            case 3:
                keyType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_MASTER_KEY;
                break;
            case 4:
                keyType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_CONFIGURATION_KEY;
                break;
            case 5:
                keyType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_LEVEL_2_SWITCH_KEY;
                break;
            case 6:
                keyType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_LEVEL_3_SWITCH_KEY;
                break;
            case 7:
                keyType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_SL1_AUTHENTICATION_KEY;
                break;
            case 8:
                keyType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_VIRTUAL_CARD_SELECT_KEY;
                break;
            case 9:
                keyType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_PROXIMITY_CHECK_KEY;
                break;
            case 10:
                keyType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_VIRTUAL_CARD_POLLING_ENCRYPTION_KEY;
                break;
            case 11:
                keyType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_VIRTUAL_CARD_POLLING_MAC_KEY;
                break;
        }

        int blockType = 0x00;

        switch (blockTypeIndex)
        {
            case 0:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_DATA_BLOCK;
                break;
            case 1:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_CONFIGURATION_BLOCK;
                break;
            case 2:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_INSTALLATION_IDENTIFIER;
                break;
            case 3:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_ATS_INFORMATION;
                break;
            case 4:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_FIELD_CONFIGURATION_BLOCK;
                break;
            case 5:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_AES_SECTOR_KEY_A;
                break;
            case 6:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_AES_SECTOR_KEY_B;
                break;
            case 7:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_MASTER_KEY;
                break;
            case 8:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_CONFIGURATION_KEY;
                break;
            case 9:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_LEVEL_2_SWITCH_KEY;
                break;
            case 10:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_LEVEL_3_SWITCH_KEY;
                break;
            case 11:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_SL1_AUTHENTICATION_KEY;
                break;
            case 12:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_VIRTUAL_CARD_SELECT_KEY;
                break;
            case 13:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_PROXIMITY_CHECK_KEY;
                break;
            case 14:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_VIRTUAL_CARD_POLLING_ENCRYPTION_KEY;
                break;
            case 15:
                blockType = UemReader.CommandsCards.CommandsMifarePlus.UEM_MIFARE_PLUS_VALUE_TYPE_VIRTUAL_CARD_POLLING_MAC_KEY;
                break;
        }

        switch(view.getId()) {
            case R.id.mfp_button_ratspps:
                byte[] atr = ((MainActivity) getActivity()).mUemR.Cards.ISO14443A.activateTCLdeprecated();
                ((MainActivity) getActivity()).appendLog(log, "RATS+PPS", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                        ), ((MainActivity) getActivity()).mUemR.getLastError().equals(UemReader.UEM_STATUS_SUCCESS)?String.format("ATR: %s",
                        UemReader.Helper.byteArrayToHexString(atr)
                        ):null
                );
                break;
            case R.id.mfp_button_auth_first:
                if (!useSAM) {
                    ((MainActivity) getActivity()).mUemR.Cards.MifarePlus.authenticateFirst(sector, keyType, flashKey);
                    ((MainActivity) getActivity()).appendLog(log, "Authenticate First", String.format("%s, Status: 0x%02x",
                            ((MainActivity) getActivity()).mUemR.getLastError(),
                            ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                    ));
                } else {
                    ((MainActivity) getActivity()).mUemR.Cards.MifarePlus.authenticateFirstSAM(
                            sector,
                            keyType,
                            samKeyNo,
                            samKeyVer
                            );
                    ((MainActivity) getActivity()).appendLog(log, "Authenticate First SAM:", String.format("%s, Status: 0x%02x, SW1=0x%02x SW2=0x%02x",
                            ((MainActivity) getActivity()).mUemR.getLastError(),
                            ((MainActivity) getActivity()).mUemR.getLastErrorCode(),
                            ((MainActivity) getActivity()).mUemR.SAM.SW[0],
                            ((MainActivity) getActivity()).mUemR.SAM.SW[1]
                    ));
                }
                break;
            case R.id.mfp_button_auth_following:
                if (!useSAM) {
                    ((MainActivity) getActivity()).mUemR.Cards.MifarePlus.authenticateFollowing(sector, keyType, flashKey);
                    ((MainActivity) getActivity()).appendLog(log, "Authenticate Following", String.format("%s, Status: 0x%02x",
                            ((MainActivity) getActivity()).mUemR.getLastError(),
                            ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                    ));
                } else {
                    ((MainActivity) getActivity()).mUemR.Cards.MifarePlus.authenticateFollowingSAM(sector, keyType, samKeyNo, samKeyVer);
                    ((MainActivity) getActivity()).appendLog(log, "Authenticate Following SAM:", String.format("%s, Status: 0x%02x, SW1=0x%02x SW2=0x%02x",
                            ((MainActivity) getActivity()).mUemR.getLastError(),
                            ((MainActivity) getActivity()).mUemR.getLastErrorCode(),
                            ((MainActivity) getActivity()).mUemR.SAM.SW[0],
                            ((MainActivity) getActivity()).mUemR.SAM.SW[1]
                    ));
                }
                break;
            case R.id.mfp_button_read:
                if (!useSAM) {
                    byte[] res = ((MainActivity) getActivity()).mUemR.Cards.MifarePlus.readData(blockType, sector, block, blocksCount, useCommandMAC, useCommandEncryption, useResponseMAC);
                    ((MainActivity) getActivity()).appendLog(log, "Read", String.format("%s, Status: 0x%02x",
                            ((MainActivity) getActivity()).mUemR.getLastError(),
                            ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                            ), ((MainActivity) getActivity()).mUemR.getLastError().equals(UemReader.UEM_STATUS_SUCCESS)?String.format("Data: %s",
                            UemReader.Helper.byteArrayToHexString(res)
                            ):null
                    );
                } else {
                    byte[] res = ((MainActivity) getActivity()).mUemR.Cards.MifarePlus.readDataSAM(blockType, sector, block, blocksCount, useCommandMAC, useCommandEncryption, useResponseMAC);
                    ((MainActivity) getActivity()).appendLog(log, "Read SAM", String.format("%s, Status: 0x%02x, SW1=0x%02x SW2=0x%02x",
                            ((MainActivity) getActivity()).mUemR.getLastError(),
                            ((MainActivity) getActivity()).mUemR.getLastErrorCode(),
                            ((MainActivity) getActivity()).mUemR.SAM.SW[0],
                            ((MainActivity) getActivity()).mUemR.SAM.SW[1]
                            ), ((MainActivity) getActivity()).mUemR.getLastError().equals(UemReader.UEM_STATUS_SUCCESS)?String.format("Data: %s",
                            UemReader.Helper.byteArrayToHexString(res)):null
                    );
                }
                break;
            case R.id.mfp_button_write:
                if (!useSAM) {
                    ((MainActivity) getActivity()).mUemR.Cards.MifarePlus.writeData(blockType, sector, block, blocksCount, data, useCommandMAC, useCommandEncryption, useResponseMAC);
                    ((MainActivity) getActivity()).appendLog(log, "Write", String.format("%s, Status: 0x%02x",
                            ((MainActivity) getActivity()).mUemR.getLastError(),
                            ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                    ));
                } else {
                    ((MainActivity) getActivity()).mUemR.Cards.MifarePlus.writeDataSAM(blockType, sector, block, blocksCount, data, useCommandMAC, useCommandEncryption, useResponseMAC);
                    ((MainActivity) getActivity()).appendLog(log, "Write SAM:", String.format("%s, Status: 0x%02x, SW1=0x%02x SW2=0x%02x",
                            ((MainActivity) getActivity()).mUemR.getLastError(),
                            ((MainActivity) getActivity()).mUemR.getLastErrorCode(),
                            ((MainActivity) getActivity()).mUemR.SAM.SW[0],
                            ((MainActivity) getActivity()).mUemR.SAM.SW[1]
                    ));
                }
                break;
            default:
        }
    }
}