package ru.microem.reader.usb_bluetooth_test.ui.reader;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.zip.CRC32;

import androidx.annotation.Nullable;
import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProviders;
import ru.microem.reader.usb_bluetooth_test.MainActivity;
import ru.microem.reader.usb_bluetooth_test.R;
import ru.microem.readerlibrary.UemReader;

public class ReaderFragment extends Fragment {

    private ReaderViewModel readerViewModel;

    private View mRoot = null;

    private ArrayList<String> mListBLE = null;

    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        readerViewModel =
                ViewModelProviders.of(this).get(ReaderViewModel.class);
        View root = inflater.inflate(R.layout.fragment_reader, container, false);
        final TextView textView = root.findViewById(R.id.text_reader);
        readerViewModel.getText().observe(this, new Observer<String>() {
            @Override
            public void onChanged(@Nullable String s) {
                textView.setText(s);
            }
        });

        mRoot = root;

        ((MainActivity)getActivity()).mReaderFragment = this;
//UemReader.Helper.CRC32 ccc = new UemReader.Helper.CRC32();
//ccc.Hash(new byte[]{(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF}, 4);
//ccc.Hash(new byte[] { 0x00, 0x11, 0x22, 0x33, 0x44 }, 5);
//long res = ccc.Get();
//        CRC32 ccc2 = new CRC32();ccc2.update(new byte[]{(byte) 0xFF, (byte) 0xFF, (byte) 0xFF, (byte) 0xFF}, 0, 4);ccc2.update(new byte[] { 0x00, 0x11, 0x22, 0x33, 0x44 }, 0, 5);long res2 = ccc2.getValue();

        SharedPreferences sharedPref = getActivity().getPreferences(Context.MODE_PRIVATE);
        ((EditText)root.findViewById(R.id.rdr_edit_signal_count)).setText(sharedPref.getString("rdr_edit_signal_count", "1"));
        ((Spinner)root.findViewById(R.id.rdr_spinner_color)).setSelection(sharedPref.getInt("rdr_spinner_color", 1));
        ((Spinner)root.findViewById(R.id.rdr_spinner_post_color)).setSelection(sharedPref.getInt("rdr_spinner_post_color", 2));
        ((EditText)root.findViewById(R.id.rdr_edit_key)).setText(sharedPref.getString("rdr_edit_key", "8459DBB289B95566CA7881A0DD47C67D"));
        ((EditText)root.findViewById(R.id.rdr_edit_flash_address)).setText(sharedPref.getString("rdr_edit_flash_address", "0"));
        ((TextView)root.findViewById(R.id.rdr_log)).setText(sharedPref.getString("rdr_log", ""));

        return root;
    }

    public void onPause() {
        SharedPreferences sharedPref = getActivity().getPreferences(Context.MODE_PRIVATE);
        sharedPref.edit().putString("rdr_edit_signal_count", ((EditText)mRoot.findViewById(R.id.rdr_edit_signal_count)).getText().toString()).apply();
        sharedPref.edit().putInt("rdr_spinner_color", ((Spinner)mRoot.findViewById(R.id.rdr_spinner_color)).getSelectedItemPosition()).apply();
        sharedPref.edit().putInt("rdr_spinner_post_color", ((Spinner)mRoot.findViewById(R.id.rdr_spinner_post_color)).getSelectedItemPosition()).apply();
        sharedPref.edit().putString("rdr_edit_key", ((EditText)mRoot.findViewById(R.id.rdr_edit_key)).getText().toString()).apply();
        sharedPref.edit().putString("rdr_edit_flash_address", ((EditText)mRoot.findViewById(R.id.rdr_edit_flash_address)).getText().toString()).apply();
        sharedPref.edit().putString("rdr_log", ((TextView)mRoot.findViewById(R.id.rdr_log)).getText().toString()).apply();

        super.onPause();
    }

    @Override
    public void onViewCreated(View view, @Nullable Bundle savedInstanceState) {

    }

    /** Called when the user touches the button */
    public void onReaderCommand(View view) {
        EditText editSignalCount = mRoot.findViewById(R.id.rdr_edit_signal_count);
        int signalCount = Integer.parseInt(editSignalCount.getText().toString());
        Spinner spinnerColor = (Spinner)mRoot.findViewById(R.id.rdr_spinner_color);
        int color = spinnerColor.getSelectedItemPosition();
        Spinner spinnerPostColor = (Spinner)mRoot.findViewById(R.id.rdr_spinner_post_color);
        int postColor = spinnerPostColor.getSelectedItemPosition();
        EditText editKey = mRoot.findViewById(R.id.rdr_edit_key);
        byte[] key = UemReader.Helper.hexStringToByteArray(editKey.getText().toString());
        EditText editKeyAddress = mRoot.findViewById(R.id.rdr_edit_flash_address);
        int keyAddress = Integer.parseInt(editKeyAddress.getText().toString());
        TextView log = mRoot.findViewById(R.id.rdr_log);
        byte[] res = null;
        switch(view.getId()) {
            case R.id.rdr_button_version:
                res = ((MainActivity) getActivity()).mUemR.Reader.getVersion();
                ((MainActivity) getActivity()).appendLog(log, "Get Version", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                        ), ((MainActivity) getActivity()).mUemR.getLastError().equals(UemReader.UEM_STATUS_SUCCESS)?String.format("Version: %s",
                            UemReader.Helper.byteArrayToHexString(res)
                        ):null
                );
                break;
            case R.id.rdr_button_serial:
                res = ((MainActivity) getActivity()).mUemR.Reader.getSerial();
                ((MainActivity) getActivity()).appendLog(log, "Get Serial", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                        ), ((MainActivity) getActivity()).mUemR.getLastError().equals(UemReader.UEM_STATUS_SUCCESS)?String.format("Serial: %s",
                        UemReader.Helper.byteArrayToHexString(res)
                        ):null
                );
                break;
            case R.id.rdr_button_on:
                ((MainActivity) getActivity()).mUemR.Reader.switchOnRadioController();
                ((MainActivity) getActivity()).appendLog(log, "Radio Controller On", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));
            case R.id.rdr_button_off:
                ((MainActivity) getActivity()).mUemR.Reader.switchOffRadioController();
                ((MainActivity) getActivity()).appendLog(log, "Radio Controller Off", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));
                break;
            case R.id.rdr_button_beep:
                ((MainActivity) getActivity()).mUemR.Reader.beep(signalCount);
                ((MainActivity) getActivity()).appendLog(log, "Beep", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));
                break;
            case R.id.rdr_button_led:
                ((MainActivity) getActivity()).mUemR.Reader.blink(color, signalCount, postColor);
                ((MainActivity) getActivity()).appendLog(log, "Led", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));
                break;
            case R.id.rdr_button_write_flash:
                ((MainActivity) getActivity()).mUemR.Reader.writeFlashValue(keyAddress, key);
                ((MainActivity) getActivity()).appendLog(log, "Write Flash", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));
                break;
            case R.id.rdr_button_clear_flash:
                ((MainActivity) getActivity()).mUemR.Reader.eraseFlash();
                ((MainActivity) getActivity()).appendLog(log, "Erase Flash", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));
                break;
            case R.id.rdr_button_authenticate:
                ((MainActivity) getActivity()).mUemR.Reader.authenticateReader(keyAddress, key);
                ((MainActivity) getActivity()).appendLog(log, "Authenticate Reader", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));
                break;
            case R.id.rdr_button_authentication_reset:
                ((MainActivity) getActivity()).mUemR.Reader.resetReaderAuthentication();
                ((MainActivity) getActivity()).appendLog(log, "Reset Reader Authentication", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));
                break;
                /*case R.id.send:
                TextView textView = (TextView) mRoot.findViewById(R.id.customCmd);
                byte[] cmd = UemReader.Helper.hexStringToByteArray(textView.getText().toString());
                byte[] res = ((MainActivity)getActivity()).mUemR.Reader.directIOReader(cmd);
                if (res != null) {
                    TextView resView = (TextView) mRoot.findViewById(R.id.outtext);
                    resView.setText("status: " + ((MainActivity)getActivity()).mUemR.getLastErrorCode() + " result: " + UemReader.Helper.byteArrayToHexString(res));
                } else {
                    ((MainActivity)getActivity()).runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            Toast.makeText(getActivity().getApplicationContext(),
                                    ((MainActivity)getActivity()).mUemR.getLastError(), Toast.LENGTH_LONG)
                                    .show();
                        }
                    });
                }

                break;*/
            default:
        }
    }

}