
#ifdef __cplusplus
 extern "C" {
#endif // __cplusplus

#include <windows.h>
#include "dbglog.h"

ULONG CDECL DbgLog (PTCHAR Format, ...)
{
 ULONG		Result;
 HANDLE		hLogFile;
 va_list	arglist;
 TCHAR		LogBuffer[256];

 hLogFile = CreateFile (TEXT (DBG_LOG_FILE_NAME), GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
 if (hLogFile != INVALID_HANDLE_VALUE)
 {
	SetFilePointer (hLogFile, 0, NULL, FILE_END);
	va_start (arglist, Format);
	wvsprintf (&LogBuffer[0], Format, arglist);
	WriteFile (hLogFile, &LogBuffer[0], lstrlen (&LogBuffer[0]) * sizeof (LogBuffer[0]), &Result, NULL);
	CloseHandle (hLogFile);
 }
 else
	Result = 0;
 return Result;
}

BOOL NTAPI DbgLogPacket (ULONG PacketNumber, PUCHAR PacketData, ULONG PacketLength)
{
 BOOL	Result;
 TCHAR	TempBuffer[MAX_PATH];
 HANDLE	hLogFile;
 ULONG	BytesWritten;

 wsprintf (&TempBuffer[0], TEXT ("\\header%lu.bin"), PacketNumber);
 hLogFile = CreateFile (&TempBuffer[0], GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
 if (hLogFile != INVALID_HANDLE_VALUE)
 {
	Result = WriteFile (hLogFile, PacketData, PacketLength, &BytesWritten, NULL);
	Result = CloseHandle (hLogFile) && Result;
 }
 else
	Result = FALSE;
 return Result;
}

BOOL NTAPI DbgLogPacket2 (ULONG PacketNumber, PUCHAR PacketData, ULONG PacketLength)
{
 BOOL	Result;
 TCHAR	TempBuffer[MAX_PATH];
 HANDLE	hLogFile;
 ULONG	BytesWritten;

 wsprintf (&TempBuffer[0], TEXT ("\\packet%lu.bin"), PacketNumber);
 hLogFile = CreateFile (&TempBuffer[0], GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
 if (hLogFile != INVALID_HANDLE_VALUE)
 {
	Result = WriteFile (hLogFile, PacketData, PacketLength, &BytesWritten, NULL);
	Result = CloseHandle (hLogFile) && Result;
 }
 else
	Result = FALSE;
 return Result;
}

#ifdef __cplusplus
 };
#endif // __cplusplus
