
#ifndef __UEMUSB_H__
#define __UEMUSB_H__

#ifdef __cplusplus
 extern "C" {
#endif

#define UEMUSB_DRIVER_NAME		"uemusb"
#define UEMUSB_VENDOR_ID		49745
#define UEMUSB_DEVICE_ID		4874

#define UEM_SCR_MAX_TRANSFER_SIZE	64
#define UEM_SCR_BUFFER_SIZE		300

#define UEMUSB_CURRENT_VERSION		0x01

BOOL NTAPI DbgLogPacket (ULONG PacketNumber, PUCHAR PacketData, ULONG PacketLength);
BOOL NTAPI DbgLogPacket2 (ULONG PacketNumber, PUCHAR PacketData, ULONG PacketLength);

typedef struct _DEVICE_EXTENSION
{
 LPCUSB_FUNCS	UsbFuncs;
 USB_PIPE	UsbPipeIn;
 USB_PIPE	UsbPipeOut;
 WORD		FrameId;
 HANDLE		hTransferEvent;
 HANDLE		hDevice;
} DEVICE_EXTENSION, *PDEVICE_EXTENSION;

#define DBGLOG_DEVICE_EXTENSION(DeviceExtension) \
{\
	DBGLOG ((TEXT ("DeviceExtension: 0x%lX\r\n"), DeviceExtension)); \
	DBGLOG ((TEXT ("DeviceExtension->UsbFuncs: 0x%lX\r\n"), ((PDEVICE_EXTENSION) DeviceExtension)->UsbFuncs)); \
	DBGLOG ((TEXT ("DeviceExtension->UsbPipeIn: 0x%lX\r\n"), ((PDEVICE_EXTENSION) DeviceExtension)->UsbPipeIn)); \
	DBGLOG ((TEXT ("DeviceExtension->UsbPipeOut: 0x%lX\r\n"), ((PDEVICE_EXTENSION) DeviceExtension)->UsbPipeOut)); \
}

#define DBGLOG_USB_ENDPOINT_DESCRIPTOR(UsbEndpointDescriptor) \
{\
	DBGLOG ((TEXT ("UsbEndpointDescriptor: 0x%lX\r\n"), UsbEndpointDescriptor)); \
	DBGLOG ((TEXT ("UsbEndpointDescriptor->bLength: %u\r\n"), ((PUSB_ENDPOINT_DESCRIPTOR) UsbEndpointDescriptor)->bLength)); \
	DBGLOG ((TEXT ("UsbEndpointDescriptor->bDescriptorType: 0x%X\r\n"), ((PUSB_ENDPOINT_DESCRIPTOR) UsbEndpointDescriptor)->bDescriptorType)); \
	DBGLOG ((TEXT ("UsbEndpointDescriptor->bEndpointAddress: 0x%X\r\n"), ((PUSB_ENDPOINT_DESCRIPTOR) UsbEndpointDescriptor)->bEndpointAddress)); \
	DBGLOG ((TEXT ("UsbEndpointDescriptor->bmAttributes: 0x%X\r\n"), ((PUSB_ENDPOINT_DESCRIPTOR) UsbEndpointDescriptor)->bmAttributes)); \
	DBGLOG ((TEXT ("UsbEndpointDescriptor->wMaxPacketSize: %u\r\n"), ((PUSB_ENDPOINT_DESCRIPTOR) UsbEndpointDescriptor)->wMaxPacketSize)); \
	DBGLOG ((TEXT ("UsbEndpointDescriptor->bInterval: %u\r\n"), ((PUSB_ENDPOINT_DESCRIPTOR) UsbEndpointDescriptor)->bInterval)); \
}

BOOL USBDeviceNotificationCallback (LPVOID lpvNotifyParameter, DWORD dwCode, LPDWORD* dwInfo1, LPDWORD* dwInfo2, LPDWORD* dwInfo3, LPDWORD* dwInfo4);
DWORD Transaction (PDEVICE_EXTENSION DeviceExtension, PVOID lpInBuffer, DWORD nInBufferSize, PVOID lpOutBuffer, DWORD nOutBufferSize, PDWORD lpBytesReturned);
DWORD Transaction2 (PDEVICE_EXTENSION DeviceExtension, PVOID lpInBuffer, DWORD nInBufferSize, PVOID lpOutBuffer, DWORD nOutBufferSize, PDWORD lpBytesReturned);

#ifdef __cplusplus
 };
#endif

#endif // __UEMUSB_H__
