
//==============================================================================
//             SAM-:    RFID-
//==============================================================================

// Clscrfl_SAM.h : main header file for the SAM CLSCRFL DLL EXTENSION

//   RFID-     :
//==============================================================================
//        SAM-
//------------------------------------------------------------------------------
//    SAM
//     SAM-
//      APDU
//    SAM   AV1   AV2
//    () SAM
//     Mifare Classic
//     Mifare Classic
//     Mifare Classic
//     Value  Mifare Classic
//     Mifare Classic
//==============================================================================

//      :
//          0 -  
// 0x80100001 -   ,     
//                 CLSCRF_GetLastInternalError



#if !defined(AFX_CLSCRF_H__DE290562_87D9_41F4_A1CD_3B80EFEBA737__INCLUDED_)
#define AFX_CLSCRF_H__DE290562_87D9_41F4_A1CD_3B80EFEBA737__INCLUDED_

#if _MSC_VER > 1000
	#pragma once
#endif // _MSC_VER > 1000



#ifdef CLSCRF_EXPORTS
	#define CLSCRF_API EXTERN_C __declspec(dllexport)
#else
	#define CLSCRF_API EXTERN_C __declspec(dllimport)
#endif

#ifndef _LPCBYTE_DEFINED
	#define _LPCBYTE_DEFINED
	typedef const BYTE *LPCBYTE;
#endif


#undef STRING_VERSION
#define STRING_VERSION      "S4.12"

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:       
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_GetStatusDescription(	IN BYTE ucSW1,
												IN BYTE ucSW2,
												OUT LPTSTR pError);
//
//       
//
// pucSW1   1 ;
// pucSW2   2 .
// pError -     unicode (512 ), 
//              
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:   SAM
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_SetCurrentHolder(	IN LPVOID pReader,
											IN BYTE ucNumSAM );
//
//   SAM
//        
//        
//
// pReader    - (.  CLSCRF_Create);
// ucNumSAM     0  3.
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:    SAM-
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_GetCurrentHolder(	IN LPVOID pReader,
											OUT LPBYTE pucNumSAM );
//
//    SAM-
//
// pReader    - (.  CLSCRF_Create);
// pucNumSAM     0  3.
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:     APDU
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_APDU(  IN     LPVOID  pReader,
                              IN     LPCBYTE pbSendBuffer, 
                              IN     DWORD   dwSendLength, 
                                 OUT LPBYTE  pbRecvBuffer, 
                              IN OUT LPDWORD pdwRecvLength );
//
//     APDU
//
// pReader    - (.  CLSCRF_Create);
// pbSendBuffer  ;
// dwSendLength   ;
// pbRecvBuffer  ,    SW1  SW2;
// pdwRecvLength   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:  SAM-
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_Lock(IN LPVOID pReader,
							IN BYTE ucLC,
							IN BYTE ucKeyKind,
							IN BYTE ucKeyNo, 
							IN BYTE ucKeyVer, 
							IN PBYTE pUnlockKey, 
							IN BYTE ucUnlockKeyNo,
							IN BYTE ucUnlockKeyVer,
							//IN DWORD dwMaxChainBlocks,
							OUT LPBYTE pucSW1,
							OUT LPBYTE pucSW2 );
//
//  SAM-
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucKeyKind[1] -  :
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// ucKeyNo[1] -     ;
// ucKeyVer[1] -     ;
// pUnlockKey[24] -   
// ucUnlockKeyNo[1] -    ;
// ucUnlockKeyVer[1] -    ;
//                  ( NULL,     );
// dwMaxChainBlocks -     
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:  SAM-
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_Unlock(	IN LPVOID pReader,
								IN BYTE ucLC,
								IN BYTE ucKeyKind,
								IN BYTE ucKeyNo, 
								IN BYTE ucKeyVer, 
								IN PBYTE pUnlockKey, 
								OUT LPBYTE pucSW1,
								OUT LPBYTE pucSW2 );
//
//  SAM-
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucKeyKind[1] -  :
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// ucKeyNo[1] -    ;
// ucKeyVer[1] -    ;
// pUnlockKey[24] -   
//                  ( NULL,     );
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:     SAM-
//------------------------------------------------------------------------------
//

typedef struct _SAM_VERSION
{
	struct
	{
		BYTE ucVendorID;
		BYTE ucType;
		BYTE ucSubType;
		BYTE ucMajorVersion;
		BYTE ucMinorVersion;
		BYTE ucStorageSize;
		BYTE ucProtocolType;
	} HardwareVersionInfo;
	struct
	{
		BYTE ucVendorID;
		BYTE ucType;
		BYTE ucSubType;
		BYTE ucMajorVersion;
		BYTE ucMinorVersion;
		BYTE ucStorageSize;
		BYTE ucProtocolType;
	} SoftwareVersionInfo;
	struct
	{
		BYTE UID[7];
		BYTE BatchNumber[5];
		BYTE ucProductionDay;
		BYTE ucProductionMonth;
		BYTE ucProductionYear;
		union
		{
			struct
			{
				BYTE RFU:3;
				BYTE fDisable_DESFirePICCKeyChange:1;
				BYTE fDisable_Decryption:1;
				BYTE fDisable_Encryption:1;
				BYTE fDisable_MAC_Verification:1;
				BYTE fDisable_MAC_Generation:1;
			};
			BYTE ucBits;
		} CryptoSettings;
	} ManufacturerData;
	BYTE ucMode;
} SAM_VERSION;

CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_GetVersion(	IN LPVOID pReader,
									IN BYTE ucLC,
									OUT SAM_VERSION* pVersion,
									OUT LPBYTE pucSW1,
									OUT LPBYTE pucSW2 );
//
//     SAM-
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// pVersion -    SAM-;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:  SAM-
//------------------------------------------------------------------------------
//
typedef union _SAM_AUTH_MODE_AV1
{
	struct
	{
		BYTE fKeyDiversifiedWith8Or16BytesDivInp:1;
		BYTE fUseLogicalChannelForCMACCalculation:1;
		BYTE fUseSecretKeyForCrypto:1;
		BYTE fDiversifyUsingOneEncryptionRound:1;
		BYTE fUseMIFARE_SAM_AV2_ModeKeyDiversificationMethods:1;
		BYTE RFU:3;
	};
	BYTE ucBitMask;
} SAM_AUTH_MODE_AV1;

CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_AuthenticateHost(IN LPVOID pReader,
										IN BYTE ucLC,
										IN BYTE ucHostMode,
										IN BYTE ucKeyKind,
										IN BYTE ucKeyNo, 
										IN BYTE ucKeyVer, 
										IN PBYTE pKey, 
										//IN BYTE ucDivLength, 
										//IN LPBYTE pbDivInp, 
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );
//
//  SAM-  
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucHostMode[1] -  :
//					0: Plain;
//					1: MAC Protection;
//					2: Full Protection;
//					3: RFU;
// ucKeyKind[1] -  :
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// ucKeyNo[1] -    ;
// ucKeyVer[1] -    ;
// pKey[24] -   ;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:  Offline- SAM-
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_ActivateOfflineKey(	IN LPVOID pReader,
											IN BYTE ucLC,
											IN BYTE ucKeyNo, 
											IN BYTE ucKeyVer, 
											IN BYTE ucDivLength, 
											IN LPBYTE pbDivInp, 
											OUT LPBYTE pucSW1,
											OUT LPBYTE pucSW2 );
//
//  Offline- SAM-
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucKeyNo[1] -    ;
// ucKeyVer[1] -    ;
// ucDivLength[1] -    (8-  DES, 
//                  16-  AES  1-31-  );
// pbDivInp[1-31] -   ( DES, AES   );
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:   SAM   AV1   AV2
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_SwitchToAV2Mode(	IN LPVOID pReader,
										IN BYTE ucLC,
										IN LPBYTE pbNewPosAkey, 
										IN BYTE ucNewPosAkeyVer, 
										IN LPBYTE pbNewPosBkey, 
										IN BYTE ucNewPosBkeyVer, 
										IN LPBYTE pbNewPosCkey, 
										IN BYTE ucNewPosCkeyVer, 
										IN DWORD dwMaxChainBlocks,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );
//
//   SAM   AV1   AV2
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// pbNewPosAkey[16] -   - AES-128   A;
// ucNewPosAkeyVer[1] -     AES-128   A  0  255;
// pbNewPosBkey[16] -   - AES-128   B;
// ucNewPosBkeyVer[1] -     AES-128   B  0  255;
// pbNewPosCkey[16] -   - AES-128   C;
// ucNewPosCkeyVer[1] -     AES-128   C  0  255;
// dwMaxChainBlocks -     
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:   () SAM
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_Reset(	IN LPVOID pReader );
//
//   () SAM
//
// pReader    - (.  CLSCRF_Create).
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:   SAM-   
//------------------------------------------------------------------------------
//

typedef union _SAM_SETTINGS
{
	struct
	{
		WORD bAllowDumpSessionKey:1;
		WORD bAllowCryptoWithSecretKey:1;
		WORD bfKeepInitVector:1;
		WORD wKeyKind:3;
		WORD RFU:2;
		WORD bAV1HigherCmdSecLevel:1;
		WORD bDisableKeyEntry:1;
		WORD bAV1EnableHostAuth:1;
		WORD bDisableChangeKey:1;
		WORD bDisableDecryption:1;
		WORD bDisableEncryption:1;
		WORD bDisableVerifyMAC:1;
		WORD bDisableGenerateMAC:1;
	};
	struct
	{
		WORD :8;
		WORD bAV2EnableHostAuthKey:1;
		WORD :1;
		WORD bAV1AV2AllowLockUnlock:1;
		WORD :5;
	};
	WORD wSettings;
} SAM_SETTINGS;

typedef union _SAM_EXT_SETTINGS
{
	struct
	{
		BYTE iKeyClass:3;
		BYTE bAllowDumpSecretKey:1;
		BYTE bRestrictToDiversifiedUse:1;
		BYTE RFU:3;
	};
	BYTE ucExtSettings;
} SAM_EXT_SETTINGS;

typedef union _SAM_NV_PROGRAMMING_MASK
{
	struct
	{
		BYTE fUpdateKeyA:1;
		BYTE fUpdateKeyB:1;
		BYTE fUpdateKeyC:1;
		BYTE fUpdateDFKeyNoAndAID:1;
		BYTE fUpdateKeyCEK_NumberAndVersion:1;
		BYTE fUpdateRefNoKUC:1;
		BYTE fUpdateSettings:1;
		BYTE fSendKeyVersionsSeparately:1;
	};
	BYTE ucNVProgramingMask;
} SAM_NV_PROGRAMMING_MASK;

CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_GetKeyEntry(	IN LPVOID pReader,
									IN BYTE ucLC,
									IN BYTE ucKeyKind,
									IN BYTE ucKeyNo,
									OUT LPBYTE pucKeyAVersion,
									OUT LPBYTE pucKeyBVersion,
									OUT LPBYTE pucKeyCVersion,
									OUT LPDWORD pdwDESFireAID,
									OUT LPBYTE pucDESFireKeyNo,
									OUT LPBYTE pucKeyNoCEK,
									OUT LPBYTE pucKeyVCEK,
									OUT LPBYTE pucRefNoKUC,
									OUT SAM_SETTINGS* pSettings,
									OUT SAM_EXT_SETTINGS* pExtSettings,
									OUT LPBYTE pucSW1,
									OUT LPBYTE pucSW2 );
//
//   SAM-   
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucKeyKind -  :
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// ucKeyNo -  Mifare-  SAM-  1  127;
// pucKeyAVersion -    A;
// pucKeyBVersion -    B;
// pucKeyCVersion -    C;
// pdwDESFireAID - 3   AID   DESFire;
// pucDESFireKeyNo -  AID,   DESFire;
// pucKeyNoCEK -      ;
// pucKeyVCEK -    ;
// pucRefNoKUC -      ;
// pSettings -     ;
// pExtSettings -      ;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:   SAM-   
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_ChangeKeyEntry(	IN LPVOID pReader,
										IN BYTE ucLC,
										IN BYTE ucKeyNo,
										IN BYTE ucKeyKind,
										IN LPBYTE pbKeyA,
										IN LPBYTE pbKeyB,
										IN LPBYTE pbKeyC,
										IN DWORD dwDF_AID,
										IN BYTE ucDF_KeyNr,
										IN BYTE ucCEKNo,
										IN BYTE ucCEKV,
										IN BYTE ucKUC,
										IN SAM_SETTINGS* pSettings,
										IN BYTE ucKeyVerA,
										IN BYTE ucKeyVerB,
										IN BYTE ucKeyVerC,
										IN SAM_EXT_SETTINGS* pExtSettings,
										IN BOOL fPlainKeyUpdate,
										IN BOOL fOfflineKeyChange,
										IN LPBYTE pbSAM_UID,
										IN SAM_NV_PROGRAMMING_MASK* pNVProgrammingMask,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );
//
//   SAM-   
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucKeyNo -  Mifare-  SAM-  1  127;
// ucKeyKind -  :
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// pbKeyA  -  A;
// pbKeyB  -  B;
// pbKeyC  -  C;
// pbDF_AID  - 3   AID   DESFire;
// ucDF_KeyNr  -  AID,   DESFire;
// ucCEKNo -      ;
// ucCEKV  -    ;
// ucKUC   -      ;
// pSettings -     ;
// ucKeyVerA -   A;
// ucKeyVerB -   B;
// ucKeyVerC -   C;
// pExtSettings -      ;
// fPlainKeyUpdate  ,      ;
// fOfflineKeyChange   ,      (Online/Offline);
// pbSAM_UID  UID SAM-;
// pNVProgrammingMask     flash-;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:   SAM-   
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_DisableKeyEntry(	IN LPVOID pReader,
										IN BYTE ucLC,
										IN BYTE ucKeyNo,
										IN BYTE ucKeyKind,
										IN LPBYTE pbSAM_UID,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );
//
//   SAM-   
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucKeyNo -  Mifare-  SAM-  1  127;
// ucKeyKind -  :
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// pbSAM_UID  UID SAM-;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:    Mifare Classic
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifareAuthenticate(	IN LPVOID pReader,
											IN BYTE ucLC,
											IN BYTE ucAuthType,
											IN LPBYTE pbUID,
											IN BYTE ucKeyNo,
											IN BYTE ucKeyVer,
											IN BYTE ucKeyType,
											IN DWORD  dwSector,
											OUT LPBYTE pucSW1,
											OUT LPBYTE pucSW2 );
//
//    Mifare Classic
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucAuthType -  : 1 - First Authenticate,  - Following Authenticate;
// pbUID[4] -   ;
// ucKeyNo -  Mifare-  SAM-  1  127;
// ucKeyVer -  Mifare-  SAM-  0  255;
// ucKeyType -  Mifare-: 0x0a - KeyA,  KeyB;
// dwSector -   ;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:    Mifare Classic
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifareRead(	IN LPVOID pReader,
									IN BYTE ucLC,
									IN DWORD  dwSector,
									IN DWORD  dwBlock,
									OUT LPBYTE pbRecvBuffer,
									OUT LPBYTE pucSW1,
									OUT LPBYTE pucSW2 );
//
//    Mifare Classic
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// dwSector     -  ,   ;
// dwBlock      -   ;
// pbRecvBuffer -  (  16 )   ;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:    Mifare Classic
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifareWrite( IN LPVOID pReader,
									IN BYTE ucLC,
									IN DWORD  dwSector,
									IN DWORD  dwBlock,
                                    IN LPBYTE pbSendBuffer,
									OUT LPBYTE pucSW1,
									OUT LPBYTE pucSW2 );
//
//    Mifare Classic
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// dwSector     -  ,   ;
// dwBlock      -   ;
// pbSendBuffer -  (  16 )   ;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:   -    Value  Mifare Classic
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifareIncrement(	IN LPVOID pReader,
										IN BYTE ucLC,
                                        IN DWORD  dwSector,
                                        IN DWORD  dwSourceBlock,
                                        IN DWORD  dwValue,
                                        IN DWORD  dwTargetBlock,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );
//
//     Value
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// dwSector      -  ,   ;
// dwSourceBlock -   ;
// dwValue       - ,    ;
// dwTargetBlock -  -,    dwSourceBlock;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:   -    Value  Mifare Classic
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifareDecrement(	IN LPVOID pReader,
										IN BYTE ucLC,
                                        IN DWORD  dwSector,
                                        IN DWORD  dwSourceBlock,
                                        IN DWORD  dwValue,
                                        IN DWORD  dwTargetBlock,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );
//
//     Value
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// dwSector     -  ,   ;
// dwSourceBlock -   ;
// dwValue       - ,    ;
// dwTargetBlock -  -,    dwSourceBlock;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:   -    Value  Mifare Classic
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifareRestore(	IN LPVOID pReader,
										IN BYTE ucLC,
                                        IN DWORD  dwSector,
                                        IN DWORD  dwSourceBlock,
                                        IN DWORD  dwTargetBlock,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );
//
//       Value     
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// dwSector      -  ,   ;
// dwSourceBlock -   ;
// dwTargetBlock -  -;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:    Mifare Classic
//------------------------------------------------------------------------------
//
typedef union _SAM_CK_PARAM_MASK
{
	struct
	{
		BYTE bEncrypt:1;
		BYTE bDiversifyKeyA:1;
		BYTE bDiversifyKeyB:1;
		BYTE RFU:5;
	};
	BYTE ucBits;
} SAM_CK_PARAM_MASK;

CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifareChangeKey(	IN LPVOID pReader,
										IN BYTE ucLC,
										IN SAM_CK_PARAM_MASK ParamMask,
										IN BYTE ucKeyNo,
										IN BYTE ucKeyVerA,
										IN BYTE ucKeyVerB,
										IN DWORD  dwSector,
										IN LPBYTE pbAccess,
										IN LPBYTE pbUID,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );
//
//    Mifare Classic
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucParamMask -       ;
// ucKeyNo -   Mifare-  SAM-  1  127;
// ucKeyVerA -   Mifare- KeyA  SAM-  0  255;
// ucKeyVerB -   Mifare- KeyB  SAM-  0  255;
// dwSector     -  ,  ;
// pbAccess[4] -     ;
// pbUID[4] -    ( ,  Crypto  0);
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:   
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_WritePerso(	IN LPVOID pReader,
												IN BYTE  ucLC,
												IN BYTE  ucValueType,
												IN BYTE  ucSectorNumber,
												IN BYTE  ucBlockNumber,
												IN BYTE  ucKeyNumber,
												IN BYTE  ucKeyVersion,
												IN BYTE  ucLenDiv,
												IN LPBYTE pbDiv,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );
//
//     
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucValueType   -    (. )
// ucSectorNumber-   (      , 
//                    )
// ucBlockNumber -   (      , 
//                      )
// ucKeyNumber   -  Mifare-  SAM-  1  127;
// ucKeyVersion  -  Mifare-  SAM-  0  255;
// ucLenDiv      -     ;
// pbDiv		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:  
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_CommitPerso(	IN LPVOID pReader,
												IN BYTE  ucLC,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );
//
//   
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: MifarePlus:  
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_Authenticate(	IN LPVOID pReader,
												IN BYTE ucLC,
												IN BYTE  ucAuthType,
												IN BYTE  ucSecLevel,
												IN BYTE  ucKeyType,
												IN BYTE  ucSectorNumber,
												IN BYTE  ucKeyNumber,
												IN BYTE  ucKeyVersion,
												IN BYTE  ucLenCap,
												IN LPBYTE pbPcdCap,
												IN BYTE  ucLenDiv,
												IN LPBYTE pbDiv,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );
//
//   Mifare Plus
//
// pReader       -   - (.  CLSCRF_Create );
// ucLC			     0  3;
// ucAuthType	 -     (. );
// ucSecLevel	 -    (0x00 -  SL0, SL1; 0x01 -  SL2; 0x03 -  SL3);
// ucKeyType     -     (. );
// ucSectorNumber-    ;
// ucKeyNumber   -  Mifare-  SAM-  1  127;
// ucKeyVersion  -  Mifare-  SAM-  0  255;
// ucLenCap      -     (0..6,   0);
// pbPcdCap      -    ( );
// ucLenDiv      -     ;
// pbDiv		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0     ,
//       .
//
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:    SL2
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_MultiBlockRead(	IN LPVOID pReader,
													IN BYTE ucLC,
													IN BYTE ucSectorNumber,
													IN BYTE ucBlockNumber,
													IN BYTE ucBlocksCount,
													OUT LPBYTE pbData,
													OUT LPBYTE pucSW1,
													OUT LPBYTE pucSW2 );
//
//     SL2,    
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucSectorNumber -  
// ucBlockNumber -  ,     
// ucBlocksCount -   
// pbData		 -    ,     
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:    SL2
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_MultiBlockWrite(	IN LPVOID pReader,
													IN BYTE ucLC,
													IN BYTE ucSectorNumber,
													IN BYTE ucBlockNumber,
													IN BYTE ucBlocksCount,
													IN LPBYTE pbData,
													OUT LPBYTE pucSW1,
													OUT LPBYTE pucSW2 );
//
//     SL2,    
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucSectorNumber -  
// ucBlockNumber -     
// ucBlocksCount -   
// pbData		 -        
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:  
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_ReadData(	IN LPVOID pReader,
											IN BYTE ucLC,
											IN BYTE ucReadMode,
											IN BYTE ucValueType,
											IN BYTE ucSectorNumber,
											IN BYTE ucBlockNumber,
											IN BYTE ucBlocksCount,
											OUT LPBYTE pbData,
											OUT LPBYTE pucSW1,
											OUT LPBYTE pucSW2 );
//
//     SL3,   
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucReadMode    -    (. );
// ucValueType   -    (.  117   MifarePlus);
// ucSectorNumber -     ;
// ucBlockNumber -     ;
// ucBlocksCount -   ;
// pbData		 -    ,     ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:  
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_WriteData(	IN LPVOID pReader,
												IN BYTE ucLC,
												IN BYTE ucWriteMode,
												IN BYTE ucValueType,
												IN BYTE ucSectorNumber,
												IN BYTE ucBlockNumber,
												IN BYTE ucBlocksCount,
												IN LPBYTE pbData,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );
//
//     SL3,   
//
// pReader       -   - (.  CLSCRF_Create );
// ucLC			     0  3;
// ucWriteMode   -    (. );
// ucValueType   -    (.  117   MifarePlus);
// ucSectorNumber -     ;
// ucBlockNumber -     ;
// ucBlocksCount -   ;
// pbData		 -    ,       ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:  
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_Increment(	IN LPVOID pReader,
												IN BYTE ucLC,
												IN BYTE ucEncryptionMode,
												IN BYTE ucSourceSectorNumber,
												IN BYTE ucSourceBlockNumber,
												IN DWORD dwValue,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );
//
//     SL3,    
//         (Transfer Buffer) 
//
// pReader       -   - (.  CLSCRF_Create );
// ucLC			     0  3;
// ucEncryptionMode -    (. );
// ucSourceSectorNumber -   ;
// ucSourceBlockNumber -   ;
// dwValue		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:  
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_Decrement(	IN LPVOID pReader,
												IN BYTE ucLC,
												IN BYTE ucEncryptionMode,
												IN BYTE ucSourceSectorNumber,
												IN BYTE ucSourceBlockNumber,
												IN DWORD dwValue,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );
//
//     SL3,    
//         (Transfer Buffer) 
//
// pReader       -   - (.  CLSCRF_Create );
// ucLC			     0  3;
// ucEncryptionMode -    (. );
// ucSourceSectorNumber -   ;
// ucSourceBlockNumber -   ;
// dwValue		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:    
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_Transfer(	IN LPVOID pReader,
											IN BYTE ucLC,
											IN BYTE ucEncryptionMode,
											IN BYTE ucDestinationSectorNumber,
											IN BYTE ucDestinationBlockNumber,
											OUT LPBYTE pucSW1,
											OUT LPBYTE pucSW2 );
//
//     SL3,     (Transfer Buffer) 
//   
//
// pReader       -   - (.  CLSCRF_Create );
// ucLC			     0  3;
// ucEncryptionMode -    (. );
// ucDestinationSectorNumber -    ;
// ucDestinationBlockNumber -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:       
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_IncrementTransfer(	IN LPVOID pReader,
														IN BYTE ucLC,
														IN BYTE ucEncryptionMode,
														IN BYTE ucSourceSectorNumber,
														IN BYTE ucSourceBlockNumber,
														IN BYTE ucDestinationSectorNumber,
														IN BYTE ucDestinationBlockNumber,
														IN DWORD dwValue,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );
//
//     SL3,    ,
//       (Transfer Buffer)  
//   
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucEncryptionMode -    (. );
// ucSourceSectorNumber -   ;
// ucSourceBlockNumber -   ;
// ucDestinationSectorNumber -    ;
// ucDestinationBlockNumber -    ;
// dwValue		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:       
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_DecrementTransfer(	IN LPVOID pReader,
														IN BYTE ucLC,
														IN BYTE ucEncryptionMode,
														IN BYTE ucSourceSectorNumber,
														IN BYTE ucSourceBlockNumber,
														IN BYTE ucDestinationSectorNumber,
														IN BYTE ucDestinationBlockNumber,
														IN DWORD dwValue,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );
//
//     SL3,    ,
//       (Transfer Buffer)  
//   
//
// pReader       -   - (.  CLSCRF_Create );
// ucLC			     0  3;
// ucEncryptionMode -    (. );
// ucSourceSectorNumber -   ;
// ucSourceBlockNumber -   ;
// ucDestinationSectorNumber -    ;
// ucDestinationBlockNumber -    ;
// dwValue		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:   -    (Transfer Buffer)
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_Restore(	IN LPVOID pReader,
											IN BYTE ucLC,
											IN BYTE ucEncryptionMode,
											IN BYTE ucSourceSectorNumber,
											IN BYTE ucSourceBlockNumber,
											OUT LPBYTE pucSW1,
											OUT LPBYTE pucSW2 );
//
//     SL3,     -
//    (Transfer Buffer) 
//
// pReader       -   - (.  CLSCRF_Create );
// ucLC			     0  3;
// ucEncryptionMode -    (. );
// ucSourceSectorNumber -   ;
// ucSourceBlockNumber -   ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:    
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_ProximityCheck(	IN LPVOID pReader,
													IN BYTE ucLC,
													IN BYTE  ucKeyNumber,
													IN BYTE  ucKeyVersion,
													IN BYTE  ucLenDiv,
													IN LPBYTE pbDiv,
													OUT LPBYTE pucSW1,
													OUT LPBYTE pucSW2 );
//
// ,        -    
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucKeyNumber   -  Mifare-  SAM-  1  127;
// ucKeyVersion  -  Mifare-  SAM-  0  255;
// ucLenDiv      -     ;
// pbDiv		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:    
//------------------------------------------------------------------------------
//

typedef union _SAM_VC_DUO
{
	struct 
	{
		BYTE ucKeyEncNo;
		BYTE ucKeyEncVer;
		BYTE ucKeyMacNo;
		BYTE ucKeyMacVer;
	};
	DWORD dwBits;
} SAM_VC_DUO;

CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_VirtualCardSupport(	IN LPVOID pReader,
														IN BYTE ucLC,
														IN BYTE ucIIDCount,
														IN LPBYTE IIDs,
														IN BYTE ucLenCap,
														IN LPBYTE pbPcdCap,
														IN BYTE ucDuosCount,
														IN SAM_VC_DUO* Duos,
														OUT LPBYTE pbRndQ,
														OUT LPBYTE pucInfo,
														OUT LPBYTE pbPiccCap,
														OUT LPBYTE pbUID,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );
//
//         
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucIIDCount	 -      
// IIDs			 -    (16  * ucIIDCount)
// ucLenCap      -     (0..3,   0)
// pbPcdCap      -    ( )
// ucDuosCount	 -       
// Duos			 - ,     VC Polling ENC Key 
//				    VC Polling MAC Key,      
//				      SAM 
// pbRndQ		 -     12 ,     
//				   RndQ,    SAM-
// pucInfo		 -    ,    
//				      (0x83 - 4- UID, 0x80 - 7- UID)
// bpPiccCap	 -    (2 ),    
//				    
// pbUID		 -    (7 ),     UID 
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:   
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_VirtualCardSelect(	IN LPVOID pReader,
														IN BYTE ucLC,
														IN BYTE  ucKeyNumber,
														IN BYTE  ucKeyVersion,
														IN LPBYTE pbRndQ,
														IN BYTE  ucLenDiv,
														IN LPBYTE pbDiv,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );
//
//    
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucKeyNumber   -  Mifare-  SAM-  1  127;
// ucKeyVersion  -  Mifare-  SAM-  0  255;
// pbRndQ		 -     12 ,    
//				   RndQ,    SAM-
// ucLenDiv      -     ;
// pbDiv		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM: Mifare Plus:    
//------------------------------------------------------------------------------
//
CLSCRF_API LONG __stdcall 
            CLSCRF_SAM_MifarePlus_VirtualCardDeselect(	IN LPVOID pReader,
														IN BYTE ucLC,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );
//
//    
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CLSCRF_H__DE290562_87D9_41F4_A1CD_3B80EFEBA737__INCLUDED_)
