// ICode_console.cpp:      .
//

#include "stdafx.h"
#include "Windows.h"
#include "Clscrfl.h"
#include "string.h"

LONG QueryCard(int Type, PDWORD pdwValue);

void PrintID(PBYTE pID, UINT nBytes);

int _tmain(int argc, _TCHAR* argv[])
{
	LONG Status = -1;
	DWORD dwValue;
	
	if (argc > 2)
	{
		if (strstr(argv[1], "print") > 0)
		{
			dwValue = atoi(argv[2]);
			Status = QueryCard(0, &dwValue);
		}
	}

	if (Status == 0)
	{
		printf("OK\r\n");
	}
	else
	{
		printf("Error\r\n");
	}

	return 0;
}

LONG QueryCard(int Type, DWORD* pdwValue)
{
	LONG Status;

	LPVOID pReader = NULL;

	Status = CLSCRF_Create(&pReader);
	if (Status != 0) return Status;

	Status = CLSCRF_OpenUSB(pReader);
	if (Status != 0) return Status;

	Status = CLSCRF_Mfrc_On(pReader);
	if (Status != 0) return Status;

	DWORD dwState = 0;

	Status = CLSCRF_GetState(pReader, &dwState);
	if (Status != 0) return Status;

	if ((dwState & 0xFFUL) != 0x40)
	{
		Status = CLSCRF_Mfrc_Set_Rf_Mode( pReader, 0x40 );
		if (Status != 0) return Status;
	}

	const int BUF_SIZE = 300;
	BYTE RecvBuffer[BUF_SIZE];
	DWORD RecvLength = BUF_SIZE;

	Status = 
		CLSCRF_FindAllTags_15693( 
			pReader,
			0, 
			0,
			RecvBuffer,
			&RecvLength
		);

	if( Status == 0 )
	if( RecvLength > 2 )
	{
		BYTE Size = 0;
		DWORD Index = 0;
		do
		{
			Size = RecvBuffer[Index+1];
			Index += 2;

			if( Size )
			{
				switch (Type)
				{
				case 0:
					PrintID(&RecvBuffer[Index+2], *pdwValue);
					break;
				default:
					break;
				}

				Index += Size;
			}
		} while( Index < RecvLength );
	}

	Status = CLSCRF_Close(pReader);
	if (Status != 0) return Status;
	
	Status = CLSCRF_Destroy(&pReader);

	return Status;
}

void PrintID(PBYTE pID, UINT nBytes)
{
	if (nBytes > 8)
		nBytes = 8;
	for (int j = 0; j < nBytes; j++)
		printf("%02X ", pID[j]);
	printf("\r\n");
}


