﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MifareCS
{
    public partial class Form1 : Form
    {
        IntPtr _readerHandle = new IntPtr();
        byte _lastErr = 0x00;
        byte[] _UID;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Clscrfl_SAM.Create(ref _readerHandle);
        }

        private void btnOpenUSB_Click(object sender, EventArgs e)
        {
            Clscrfl_SAM.OpenUSB(_readerHandle);
            Clscrfl_SAM.Blink(_readerHandle);
            Clscrfl_SAM.Sound(_readerHandle);
            Clscrfl_SAM.CLSCRF_GetLastInternalError(_readerHandle, ref _lastErr);
            if (_lastErr == 0x00)
            {
                Clscrfl_SAM.ReaderOn(_readerHandle);
                toolStripStatusLabel1.Text = "Считыватель готов к работе";
            }
            else
            {
                toolStripStatusLabel1.Text = "Ошибка коммуникации со считывателем!";
            }
        }

        private void btnSearchCard_Click(object sender, EventArgs e)
        {
            Clscrfl_SAM.CLSCRF_Mfrc_Rf_Off_On(_readerHandle, 100);
            _UID = Clscrfl_SAM.ConnectToCard(_readerHandle);
            Clscrfl_SAM.CLSCRF_GetLastInternalError(_readerHandle, ref _lastErr);
            if (_lastErr == 0x00)
            {
                String strUID = Clscrfl_SAM.ByteArrayToHexString(_UID);
                toolStripStatusLabel1.Text = "Найдена карта " + strUID;
                lblCardUID.Text = strUID; 
            }
            else if (_lastErr == 0xFF)
            {
                toolStripStatusLabel1.Text = "Нет карты в поле!";
                return;
            }
            else
            {
                toolStripStatusLabel1.Text = "Ошибка!";
                return;
            }
        }

        private void btnAuthenticateA_Click(object sender, EventArgs e)
        {
            byte[] key = Clscrfl_SAM.HexStringToByteArray(edtKey.Text);
            byte sector = byte.Parse(edtSector.Text);
            Clscrfl_SAM.MifareStandardLoadKey(_readerHandle, sector, 0x60, key);
            uint res = Clscrfl_SAM.MifareStandardAuth(_readerHandle, 0x60, _UID, sector);
            Clscrfl_SAM.CLSCRF_GetLastInternalError(_readerHandle, ref _lastErr);
            if (res == 0 && _lastErr == 0x00)
            {
                toolStripStatusLabel1.Text = "Аутентификация прошла успешно";
            }
            else
            {
                toolStripStatusLabel1.Text = "Ошибка аутентификации!";
            }
        }

        private void btnAuthenticateB_Click(object sender, EventArgs e)
        {
            byte[] key = Clscrfl_SAM.HexStringToByteArray(edtKey.Text);
            byte sector = byte.Parse(edtSector.Text);
            Clscrfl_SAM.MifareStandardLoadKey(_readerHandle, sector, 0x61, key);
            uint res = Clscrfl_SAM.MifareStandardAuth(_readerHandle, 0x61, _UID, sector);
            Clscrfl_SAM.CLSCRF_GetLastInternalError(_readerHandle, ref _lastErr);
            if (res == 0 && _lastErr == 0x00)
            {
                toolStripStatusLabel1.Text = "Аутентификация прошла успешно";
            }
            else
            {
                toolStripStatusLabel1.Text = "Ошибка аутентификации!";
            }
        }

        private void btnReadData_Click(object sender, EventArgs e)
        {
            byte[] data = Clscrfl_SAM.MifareStandardRead(_readerHandle, byte.Parse(edtSector.Text), byte.Parse(edtBlock.Text));

            uint res = Clscrfl_SAM.CLSCRF_GetLastInternalError(_readerHandle, ref _lastErr);
            if (res == 0 && _lastErr == 0x00)
            {
                toolStripStatusLabel1.Text = "Чтение прошло успешно";

                edtBlockData.Text = Clscrfl_SAM.ByteArrayToHexString(data);
            }
            else
            {
                toolStripStatusLabel1.Text = "Ошибка чтения!";
            }
        }

        private void btnWriteData_Click(object sender, EventArgs e)
        {
            byte[] data = Clscrfl_SAM.HexStringToByteArray(edtBlockData.Text);

            uint res = Clscrfl_SAM.MifareStandardWrite(_readerHandle, byte.Parse(edtSector.Text), byte.Parse(edtBlock.Text), data);

            Clscrfl_SAM.CLSCRF_GetLastInternalError(_readerHandle, ref _lastErr);
            if (res == 0 && _lastErr == 0x00)
            {
                toolStripStatusLabel1.Text = "Запись прошла успешно";
            }
            else
            {
                toolStripStatusLabel1.Text = "Ошибка записи!";
            }
        }
    }
}
