﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
using System.Threading;
//using System.Threading.Tasks;
using System.Runtime.InteropServices;

namespace MifareSAM
{
    /// <summary>
    /// Класс обертка над библиотекой
    /// </summary>
    public class Clscrfl_SAM
    {
#if WindowsCE
        private const string ClscrflDll = "Clscrfl_CE.dll";
#else
        private const string ClscrflDll = "Clscrfl_SAM.dll";
#endif

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Cards_GetCount(ref int piCardsCount);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Create(ref IntPtr handle);

        [DllImport(ClscrflDll)]
        [Obsolete("Метод вызывает ошибку в библиотеке!")]
        public static extern uint CLSCRF_Destroy(IntPtr handle);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_OpenRS(IntPtr handle, uint dwIndex, uint dwBaudrate, uint dwLogFile);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_OpenUSB(IntPtr pReader, uint dwIndex, uint dwLogFile);

        [DllImport(ClscrflDll)]
        public static extern bool CLSCRF_IsOpened(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Close(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_GetLastInternalError(IntPtr pReader, out byte pbError);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Led(IntPtr pReader, Byte bBlinkColor, Byte bBlinkCount, Byte bPostColor);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Sound(IntPtr pReader, Byte nBeepCount);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Mfrc_On(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Mfrc_Off(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Get_Mfrc_Version(IntPtr pReader, IntPtr pbMfrcVersion);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_GetState(IntPtr pReader, IntPtr pdwState);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Mfrc_Set_Rf_Mode(IntPtr pReader, byte bRfMode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Mfrc_Rf_Off_On(IntPtr pReader, ushort usDelay);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_EraseFlash(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_WriteFlashValue(IntPtr pReader, uint dwAddress, IntPtr pbValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Activate_Idle_A(IntPtr pReader, IntPtr pbATQ, IntPtr pbSAK, IntPtr pbUID, ref uint pdwUIDLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Halt_A(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Activate_Wakeup_A(IntPtr pReader, IntPtr pbUID, uint UIDLength, IntPtr pbATQ, IntPtr pbSAK);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO14443A_4_RATS(IntPtr pReader, byte ucCID, IntPtr pbATS);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO14443A_4_PPS(IntPtr pReader, byte ucCID, byte ucBaudrate);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_DirectIO_Card(IntPtr pReader, IntPtr pbSendBuffer, uint uiSendLength, uint uiTimeout, IntPtr pbRecvBuffer, ref uint puiRecvLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_HostCodeKey(IntPtr pReader, IntPtr pbUncoded, IntPtr pbCoded);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_AuthKey(IntPtr pReader, byte bKeyType, IntPtr pbUID, uint dwSector, IntPtr pbCodedKey);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_WriteKeyToE2(IntPtr pReader, byte bKeyType, uint dwSector, IntPtr pbUncoded);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_AuthE2(IntPtr pReader, byte bKeyType, IntPtr pbUID, uint dwSector);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_Read(IntPtr pReader, uint dwSector, uint dwBlock, IntPtr pbRecvBuffer);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_Write(IntPtr pReader, uint dwSector, uint dwBlock, IntPtr pbSendBuffer);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralight_Read(IntPtr pReader, byte ucPage, IntPtr pbRecvBuffer);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralight_Write(IntPtr pReader, byte ucPage, IntPtr pbSendBuffer);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightEV1_GetVersion(IntPtr pReader, IntPtr pbVersion);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightEV1_ReadCounter(IntPtr pReader, byte ucCounterNumber, ref uint pdwCounterValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightEV1_IncrementCounter(IntPtr pReader, byte ucCounterNumber, uint dwCounterValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightEV1_AuthenticatePassword(IntPtr pReader, ref uint pPassword, ref ushort pPasswordAcknowledge);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_WritePersoExplicit(IntPtr pReader, byte ucValueType, byte ucSectorNumber, byte ucBlockNumber, IntPtr pbData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_CommitPerso(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_Authenticate(IntPtr pReader, byte ucSL, byte ucT_CL, byte ucAuthType, byte ucKeyType, byte ucSectorNumber, ushort usKeyFlashAddress, byte ucLenDIV, IntPtr pbDIV, byte ucLenCap, IntPtr pbPCDCap, IntPtr pbRCOut, IntPtr pbTCOut);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_ReadData(IntPtr pReader, byte ucEncryptionMode, byte ucValueType, byte ucSectorNumber, byte ucBlockNumber, byte ucBlocksCount, IntPtr pbData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_WriteData(IntPtr pReader, byte ucEncryptionMode, byte ucValueType, byte ucSectorNumber, byte ucBlockNumber, byte ucBlocksCount, IntPtr pbData, ref uint dwMACCounter, IntPtr pMACValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_LLCP_Create(IntPtr pReader, ref IntPtr phLLCPLink);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_LLCP_SetBaudrate(IntPtr pReader, byte ucDsiDri);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_SNEP_Create(IntPtr hLLCPLink, ref IntPtr hSNEP);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_SNEP_Receive(IntPtr hSNEP, IntPtr lpData, ref uint puiDataLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_SNEP_Transmit(IntPtr hSNEP, IntPtr lpData, uint uiDataLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_SNEP_Destroy(IntPtr hSNEP);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_LLCP_Destroy(IntPtr hLLCPLink);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_ForumTags_SupposeTypeISO14443A(IntPtr pReader, IntPtr ATQ, byte SAK, ref byte pucTagType);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_ForumTags_BeginType4(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_ForumTags_Format(IntPtr pReader, byte ucTagType);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_ForumTags_Read(IntPtr pReader, byte ucTagType, IntPtr lpData, ref uint puiDataLength, ref byte pucPermissions);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_ForumTags_Write(IntPtr pReader, byte ucTagType, IntPtr lpData, uint uiDataLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_FindAllTags_15693(IntPtr pReader, byte ucFlags, byte ucAfi, IntPtr lpData, ref uint puiDataLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ReadMultipleBlocks_15693(IntPtr pReader,
                                                                byte ucFlags,
                                                                byte ucReadMultipleBlock,
                                                                IntPtr pbUID,
                                                                byte ucFirstBlockNumber,
                                                                ref byte pucNumberOfBlocks,
                                                                ref byte pucFlags,
                                                                IntPtr pbBlockSecurityStatus,
                                                                IntPtr pbData,
                                                                ref byte pucErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_WriteSingleBlock_15693(IntPtr pReader,
                                                                byte ucFlags,
                                                                byte ucWriteSingleBlock,
                                                                IntPtr pbUID,
                                                                byte ucBlockNumber,
                                                                IntPtr pbData,
                                                                ref byte pucFlags,
                                                                ref byte pucErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_SetCurrentHolder(IntPtr pReader, byte ucNumSAM);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_GetVersion(IntPtr pReader, byte ucLC, IntPtr pVersion, ref byte pucSW1, ref byte pucSW2);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_GetKeyEntry(IntPtr pReader,
									                    byte ucLC,
									                    byte ucKeyKind,
									                    byte ucKeyNo,
									                    ref byte pucKeyAVersion,
									                    ref byte pucKeyBVersion,
									                    ref byte pucKeyCVersion,
									                    ref uint pdwDESFireAID,
									                    ref byte pucDESFireKeyNo,
									                    ref byte pucKeyNoCEK,
									                    ref byte pucKeyVCEK,
									                    ref byte pucRefNoKUC,
									                    ref ushort pSettings,
                                                        ref byte pExtSettings,
									                    ref byte pucSW1,
									                    ref byte pucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_ChangeKeyEntry(IntPtr pReader,
										                    byte ucLC,
										                    byte ucKeyNo,
										                    byte ucKeyKind,
										                    IntPtr pbKeyA,
										                    IntPtr pbKeyB,
										                    IntPtr pbKeyC,
										                    uint dwDF_AID,
										                    byte ucDF_KeyNr,
										                    byte ucCEKNo,
										                    byte ucCEKV,
										                    byte ucKUC,
                                                            ref ushort pSettings,
										                    byte ucKeyVerA,
										                    byte ucKeyVerB,
										                    byte ucKeyVerC,
                                                            ref byte pExtSettings,
										                    uint fPlainKeyUpdate,
                                                            uint fOfflineKeyChange,
										                    IntPtr pbSAM_UID,
                                                            ref byte pNVProgrammingMask,
										                    ref byte pucSW1,
										                    ref byte pucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifareAuthenticate(IntPtr pReader,
											                    byte ucLC,
											                    byte ucAuthType,
											                    IntPtr pbUID,
											                    byte ucKeyNo,
											                    byte ucKeyVer,
											                    byte ucKeyType,
											                    uint  dwSector,
											                    ref byte pucSW1,
                                                                ref byte pucSW2);

        /// <summary>
        /// Код внутренней ошибки
        /// </summary>
        public const UInt32 InternalError = 0x80100001;
        /// <summary>
        /// Код успешного выполнения
        /// </summary>
        public const int Ok = 0;
        /// <summary>
        /// Состояние индикатора
        /// </summary>
        public enum IndicatorState
        {
            Off = 0x00,
            Green = 0x01,
            Red = 0x02,
            Yellow = 0x03
        };
        /// <summary>
        /// Преобразование массива байт в строку HEX символов
        /// </summary>
        /// <param name="ba"></param>
        /// <returns></returns>
        public static string ByteArrayToString(byte[] ba)
        {
            StringBuilder hex = new StringBuilder(ba.Length * 2);
            foreach (byte b in ba)
                hex.AppendFormat("{0:X2}", b);
            return hex.ToString();
        }
        /// <summary>
        /// Бросает исключение
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="result"></param>
        private static void ThrowException(IntPtr handle, uint result)
        {
            if (result == InternalError)
            {
                //throw new CardReaderException("Ошибка внуреняя: " + LastInternalError(handle).ToString("X2"));
            }
            else
            {
                //throw new CardReaderException("Ошибка: " + result.ToString("X8"));
            }
        }
        /// <summary>
        /// Создание интерфейса
        /// </summary>
        /// <param name="handle"></param>
        internal static void Create(ref IntPtr handle)
        {
            //string path = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase);
            //Console.WriteLine(System.IO.File.Exists(path + "\\" + ClscrflDll) ? "File exists." : "File does not exist.");
            var lowLevelResult = CLSCRF_Create(ref handle);
            if (lowLevelResult != 0)
            {
                ThrowException(handle, lowLevelResult);
            }
        }
        /// <summary>
        /// Открытие интерфейса USB
        /// </summary>
        /// <param name="handle"></param>
        internal static void OpenUSB(IntPtr handle)
        {
            var lowLevelResult = CLSCRF_OpenUSB(handle, 0, 0);
            if (lowLevelResult != 0)
            {
                ThrowException(handle, lowLevelResult);
            }
        }
        /// <summary>
        /// Преобразование названия порта в номер
        /// </summary>
        /// <param name="port"></param>
        /// <returns></returns>
        internal static byte Convert(string port)
        {
            byte result = 0;
            if (port.ToUpper().StartsWith("COM"))
            {
                try
                {
                    result = byte.Parse(port.Substring(3));
                }
                catch (Exception e)
                {
                    //throw new CardReaderException("Параметр порта должен быть вида COM1", e);
                }
            }
            else
            {
                //throw new CardReaderException("Параметр порта должен быть вида COM1");
            }
            return result;
        }
        /// <summary>
        /// Откртие интерфейса COM
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="port"></param>
        /// <returns></returns>
        internal static bool OpenCom(IntPtr handle, string port)
        {
            var portNo = Convert(port);
            var lowLevelResult = CLSCRF_OpenRS(handle, portNo, 9600, 0);
            if (lowLevelResult != 0)
            {
                ThrowException(handle, lowLevelResult);
            }
            return true;
        }
        /// <summary>
        /// Получение полследнего ошибочного состояния при внутреней ошибке
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static byte LastInternalError(IntPtr handle)
        {
            byte result = 0;

            if (CLSCRF_GetLastInternalError(handle, out result) != 0)
            {
                result = 0;
            }
            return result;
        }
        /// <summary>
        /// Помигать индикатором
        /// </summary>
        /// <param name="handle"></param>
        public static void Blink(IntPtr handle)
        {
            var lowLevelResult = CLSCRF_Led(handle, (byte)IndicatorState.Yellow, 3, (byte)IndicatorState.Off);
            if (lowLevelResult != Ok)
            {
                ThrowException(handle, lowLevelResult);
            }
        }
        /// <summary>
        /// Попищать
        /// </summary>
        /// <param name="handle"></param>
        public static void Sound(IntPtr handle)
        {
            byte nCount = 3;
            var lowLevelResult = CLSCRF_Sound(handle, nCount);
            if (lowLevelResult != Ok)
            {
                ThrowException(handle, lowLevelResult);
            }
        }
        /// <summary>
        /// Включить микросхему считывателя
        /// </summary>
        /// <param name="handle"></param>
        internal static bool ReaderOn(IntPtr handle)
        {
            var on = CLSCRF_Mfrc_On(handle);
            if (on != Ok)
            {
                Thread.Sleep(200);
                on = CLSCRF_Mfrc_On(handle);
                if (on != Ok)
                {
                    ThrowException(handle, on);
                    return false;
                }
            }
            return true;
        }
        /// <summary>
        /// Выключить микросхему считывателя
        /// </summary>
        /// <param name="handle"></param>
        internal static bool ReaderOff(IntPtr handle)
        {
            var on = CLSCRF_Mfrc_Off(handle);
            if (on != Ok)
            {
                ThrowException(handle, on);
                return false;
            }
            return true;
        }
        /// <summary>
        /// Включить радиополе считывателя
        /// </summary>
        /// <param name="handle"></param>
        internal static bool ReaderRfOn(IntPtr handle)
        {
            var on = CLSCRF_Mfrc_Rf_Off_On(handle, 10);
            if (on != Ok)
            {
                ThrowException(handle, on);
                return false;
            }
            return true;
        }
        /// <summary>
        /// Выключить радиополе считывателя
        /// </summary>
        /// <param name="handle"></param>
        internal static bool ReaderRfOff(IntPtr handle)
        {
            var on = CLSCRF_Mfrc_Rf_Off_On(handle, 0);
            if (on != Ok)
            {
                ThrowException(handle, on);
                return false;
            }
            return true;
        }
        /// <summary>
        /// Получить версию считывателя
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static string GetVersion(IntPtr handle)
        {
            var pbMfrcVersion = Marshal.AllocHGlobal(6);
            byte[] version = new byte[6];
            var sb = new StringBuilder();
            var lowLevelResult = CLSCRF_Get_Mfrc_Version(handle, pbMfrcVersion);
            Marshal.Copy(pbMfrcVersion, version, 0, 6);
            if (lowLevelResult != Ok)
            {
                ThrowException(handle, lowLevelResult);
            }
            for (int i = 0; i < version.Length; i++)
            {
                sb.AppendFormat(" {0:X2}", version[i]);
            }
            Marshal.FreeHGlobal(pbMfrcVersion);
            return sb.ToString();
        }
        /// <summary>
        /// Получить состояние микросхемы считывателя
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static string GetState(IntPtr handle)
        {
            var state = Marshal.AllocHGlobal(4);
            var result = CLSCRF_GetState(handle, state);
            var resstate = new byte[4];
            var sb = new StringBuilder();
            Marshal.Copy(state, resstate, 0, 4);
            if (result != 0)
            {
                return result.ToString("X8");
            }
            Marshal.FreeHGlobal(state);
            for (int i = 0; i < resstate.Length; i++)
            {
                sb.AppendFormat(" {0:X2}", resstate[i]);
            }
            return sb.ToString();
        }
        /// <summary>
        /// Получить состояние в массив
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static byte[] GetStateBytes(IntPtr handle)
        {
            var state = Marshal.AllocHGlobal(4);
            var result = CLSCRF_GetState(handle, state);
            var resstate = new byte[4];
            var sb = new StringBuilder();
            Marshal.Copy(state, resstate, 0, 4);
            if (result != 0)
            {
                return null;
            }
            Marshal.FreeHGlobal(state);
            return resstate;
        }
        /// <summary>
        /// Установить режим ISO14443A
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static void SetRFMode14443A(IntPtr handle)
        {
            var lowLevelResult = CLSCRF_Mfrc_Set_Rf_Mode(handle, (byte)0x00);
            if (lowLevelResult != Ok)
            {
                ThrowException(handle, lowLevelResult);
            }
        }
        /// <summary>
        /// Установить режим ISO15693
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static void SetRFMode15693(IntPtr handle)
        {
            var lowLevelResult = CLSCRF_Mfrc_Set_Rf_Mode(handle, (byte)0x40);
            if (lowLevelResult != Ok)
            {
                ThrowException(handle, lowLevelResult);
            }
        }
        /// <summary>
        /// Подключиться к карте типа ISO14443A
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static byte[] ConnectToCard14443A(IntPtr handle)
        {
            var pbATQ = Marshal.AllocHGlobal(2);
            var pbSAK = Marshal.AllocHGlobal(1);
            var pbUID = Marshal.AllocHGlobal(10);
            uint dwUIDLength = 7;
            var aia_r = CLSCRF_Activate_Idle_A(handle, pbATQ, pbSAK, pbUID, ref dwUIDLength);
            byte[] result;
            if (aia_r == 0)
            {
                result = new byte[dwUIDLength];
                Marshal.Copy(pbUID, result, 0, (int)dwUIDLength);
            }
            else
            {
                result = null;
            }
            Marshal.FreeHGlobal(pbATQ);
            Marshal.FreeHGlobal(pbSAK);
            Marshal.FreeHGlobal(pbUID);
            return result;
        }
        /// <summary>
        /// Приостановить карту типа ISO14443A
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static bool HaltCard14443A(IntPtr handle)
        {
            var aia_r = CLSCRF_Halt_A(handle);
            if (aia_r != 0)
                return false;
            return true;
        }
        /// <summary>
        /// Разбудить карту типа ISO14443A
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static bool WakeupCard14443A(IntPtr handle, byte[] uid)
        {
            var pbATQ = Marshal.AllocHGlobal(2);
            var pbSAK = Marshal.AllocHGlobal(1);
            var pbUID = Marshal.AllocHGlobal(10);
            uint dwUIDLength = (uint)uid.Length;
            Marshal.Copy(uid, 0, pbUID, uid.Length);
            var res = CLSCRF_Activate_Wakeup_A(handle, pbUID, dwUIDLength, pbATQ, pbSAK);
            bool fRes = true;
            if (res != 0)
            {
                fRes = false;
            }
            Marshal.FreeHGlobal(pbATQ);
            Marshal.FreeHGlobal(pbSAK);
            Marshal.FreeHGlobal(pbUID);
            return fRes;
        }
        /// <summary>
        /// Признак поддержки стандарта ISO18092
        /// </summary>
        public static bool _fISO18092 = false;
        /// <summary>
        /// Признак поддержки стандарта NFC Forum Tag Type #
        /// </summary>
        public static byte _ucTagType = 0;
        /// <summary>
        /// Подключиться к карте
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static byte[] ConnectToCard(IntPtr handle)
        {
            var pbATQ = Marshal.AllocHGlobal(2);
            var pbSAK = Marshal.AllocHGlobal(1);
            var pbUID = Marshal.AllocHGlobal(10);
            uint pdwUIDLength = 7;
            uint Status = CLSCRF_Activate_Idle_A(handle, pbATQ, pbSAK, pbUID, ref pdwUIDLength);
            byte[] result;
            if (Status == 0)
            {
                result = new byte[pdwUIDLength];
                Marshal.Copy(pbUID, result, 0, (int)pdwUIDLength);

                _fISO18092 = ((Marshal.ReadByte(pbSAK) & 0x44) == 0x40);

                CLSCRF_NFC_ForumTags_SupposeTypeISO14443A(handle, pbATQ, Marshal.ReadByte(pbSAK), ref _ucTagType);

                //_fTagType2 = (Marshal.ReadByte(pbSAK) == 0x00 && Marshal.ReadByte(pbATQ, 0) == 0x44 && Marshal.ReadByte(pbATQ, 1) == 0x00);
                //_fTagType4 = (Marshal.ReadByte(pbSAK) == 0x20 && Marshal.ReadByte(pbATQ, 0) == 0x44 && Marshal.ReadByte(pbATQ, 1) == 0x03);

                if (_ucTagType == 4)
                {
                    //byte CID = 0;
                    //var pbATS = Marshal.AllocHGlobal(37);

                    //Status = CLSCRF_ISO14443A_4_RATS(handle, CID, pbATS);

                    //Marshal.FreeHGlobal(pbATS);

                    //if (Status != 0)
                    //    return null;

                    //Status = CLSCRF_ISO14443A_4_PPS(handle, CID, 0 );
                    //if (Status != 0)
                    //    return null;

                    //Status = CLSCRF_Mfrc_Set_Rf_Mode(handle, 0 );
                    //if (Status != 0)
                    //    return null;

                    Status = CLSCRF_NFC_ForumTags_BeginType4(handle);
                    if (Status != 0)
                        return null;
                }
            }
            else
            {
                result = null;
            }
            Marshal.FreeHGlobal(pbATQ);
            Marshal.FreeHGlobal(pbSAK);
            Marshal.FreeHGlobal(pbUID);
            return result;
        }
        /// <summary>
        /// Подключиться к карте
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static bool RequestAnswerToSelect(IntPtr handle)
        {
            byte CID = 0;
            var pbATS = Marshal.AllocHGlobal(37);
            uint Status = 0;

            Status = CLSCRF_ISO14443A_4_RATS(handle, CID, pbATS);

            Marshal.FreeHGlobal(pbATS);

            if (Status != 0)
                return false;

            return true;
        }
        /// <summary>
        /// Загрузка ключа в ридер
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="keyType"></param>
        /// <param name="key"></param>
        internal static bool MifareStandardLoadKey(IntPtr handle, byte sector, byte keyType, byte[] key)
        {
            var pbKey = Marshal.AllocHGlobal(6);
            Marshal.Copy(key, 0, pbKey, 6);
            var lowLevelResult = CLSCRF_MifareStandard_WriteKeyToE2(handle, keyType, sector, pbKey);
            Marshal.FreeHGlobal(pbKey);
            if (lowLevelResult != 0)
            {
                ThrowException(handle, lowLevelResult);
                return false;
            }
            return true;
        }
        /// <summary>
        /// Загрузка ключа в ридер по адресу
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="keyType"></param>
        /// <param name="key"></param>
        internal static bool MifareStandardLoadKeyAddress(IntPtr handle, int address, byte keyType, byte[] key)
        {
            byte sector = AddressToSector(address);
            return MifareStandardLoadKey(handle, sector, keyType, key);
        }
        /// <summary>
        /// Авторизоваться к сектору
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="keyType"></param>
        /// <param name="UID"></param>
        /// <param name="sector"></param>
        /// <returns></returns>
        public static bool MifareStandardAuth(IntPtr handle, byte keyType, byte[] UID, byte sector)
        {
            var result = false;
            var pbUID = Marshal.AllocHGlobal(UID.Length);
            Marshal.Copy(UID, UID.Length - 4, pbUID, 4);
            var lowLevelResult = CLSCRF_MifareStandard_AuthE2(handle, keyType, pbUID, sector);
            Marshal.FreeHGlobal(pbUID);
            if (lowLevelResult == 0)
            {
                result = true;
            }
            else
            {
                ThrowException(handle, lowLevelResult);
            }
            return result;
        }
        /// <summary>
        /// Авторизоваться к сектору по адресу
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="keyType"></param>
        /// <param name="key"></param>
        internal static bool MifareStandardAuthAddress(IntPtr handle, byte keyType, byte[] UID, int address)
        {
            byte sector = AddressToSector(address);
            return MifareStandardAuth(handle, keyType, UID, sector);
        }
        /// <summary>
        /// Считать данные MifareStandard
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static byte[] MifareStandardRead(IntPtr handle, byte sector, byte block)
        {
            var pbRecvBuffer = Marshal.AllocHGlobal(16);
            var result = new byte[16];
            var lowLevelResult = CLSCRF_MifareStandard_Read(handle, sector, block, pbRecvBuffer);
            if (lowLevelResult == 0)
            {
                Marshal.Copy(pbRecvBuffer, result, 0, 16);
                Marshal.FreeHGlobal(pbRecvBuffer);
            }
            else
            {
                Marshal.FreeHGlobal(pbRecvBuffer);
                result = null;
                ThrowException(handle, lowLevelResult);
            }

            return result;
        }
        /// <summary>
        /// Считать данные MifareStandard по адресу
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static byte[] MifareStandardReadAddress(IntPtr handle, int address)
        {
            byte sector = AddressToSector((int)address);
            byte block = AddressToBlock((int)address);
            return MifareStandardRead(handle, sector, block);
        }
        /// <summary>
        /// Запись блока MifareStandard
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <param name="data"></param>
        internal static bool MifareStandardWrite(IntPtr handle, byte sector, byte block, byte[] data)
        {
            var pbSendBuffer = Marshal.AllocHGlobal(16);
            Marshal.Copy(data, 0, pbSendBuffer, 16);
            var lowLevelResult = CLSCRF_MifareStandard_Write(handle, sector, block, pbSendBuffer);
            Marshal.FreeHGlobal(pbSendBuffer);
            if (lowLevelResult != 0)
            {
                ThrowException(handle, lowLevelResult);
                return false;
            }
            return true;
        }
        /// <summary>
        /// Запись блока MifareStandard по адресу
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <param name="data"></param>
        internal static bool MifareStandardWriteAddress(IntPtr handle, int address, byte[] data)
        {
            byte sector = AddressToSector((int)address);
            byte block = AddressToBlock((int)address);
            return MifareStandardWrite(handle, sector, block, data);
        }
        private static bool _fBNBit = false;
        /// <summary>
        /// Считать страницу MifareUltralight
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static byte[] MifareUltralightRead(IntPtr handle, byte page)
        {
            var pbRecvBuffer = Marshal.AllocHGlobal(16);
            var result = new byte[16];
            var lowLevelResult = CLSCRF_MifareUltralight_Read(handle, page, pbRecvBuffer);
            if (lowLevelResult == 0)
            {
                Marshal.Copy(pbRecvBuffer, result, 0, 16);
                Marshal.FreeHGlobal(pbRecvBuffer);
            }
            else
            {
                Marshal.FreeHGlobal(pbRecvBuffer);
                result = null;
                ThrowException(handle, lowLevelResult);
            }

            return result;
        }
        /// <summary>
        /// Запись страницу MifareUltralight
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <param name="data"></param>
        internal static bool MifareUltralightWrite(IntPtr handle, byte page, byte[] data)
        {
            var pbSendBuffer = Marshal.AllocHGlobal(16);
            Marshal.Copy(data, 0, pbSendBuffer, 16);
            var lowLevelResult = CLSCRF_MifareUltralight_Write(handle, page, pbSendBuffer);
            Marshal.FreeHGlobal(pbSendBuffer);
            if (lowLevelResult != 0)
            {
                ThrowException(handle, lowLevelResult);
                return false;
            }
            return true;
        }
        /// <summary>
        /// Прочитать счетчик MifareUltralight EV1
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static bool MifareUltralightEV1ReadCounter(IntPtr handle, int counter, ref uint value)
        {
            var lowLevelResult = CLSCRF_MifareUltralightEV1_ReadCounter(handle, (byte)counter, ref value);
            if (lowLevelResult != 0)
            {
                ThrowException(handle, lowLevelResult);
                return false;
            }

            return true;
        }
        /// <summary>
        /// Инкрементировать счетчик MifareUltralight EV1
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static bool MifareUltralightEV1IncrementCounter(IntPtr handle, int counter, uint value)
        {
            var lowLevelResult = CLSCRF_MifareUltralightEV1_IncrementCounter(handle, (byte)counter, value);
            if (lowLevelResult != 0)
            {
                ThrowException(handle, lowLevelResult);
                return false;
            }

            return true;
        }
        /// <summary>
        /// Вычитать версию MifareUltralight EV1
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static byte[] MifareUltralightEV1GetVersion(IntPtr handle)
        {
            var pbVersion = Marshal.AllocHGlobal(8);
            var result = new byte[8];
            var lowLevelResult = CLSCRF_MifareUltralightEV1_GetVersion(handle, pbVersion);
            if (lowLevelResult == 0)
            {
                Marshal.Copy(pbVersion, result, 0, 8);
                Marshal.FreeHGlobal(pbVersion);
            }
            else
            {
                Marshal.FreeHGlobal(pbVersion);
                result = null;
                ThrowException(handle, lowLevelResult);
            }

            return result;
        }
        /// <summary>
        /// Аутентификация с MifareUltralight EV1
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static int MifareUltralightEV1Authenticate(IntPtr handle, uint password)
        {
            ushort ack = 0x0000;
            var lowLevelResult = CLSCRF_MifareUltralightEV1_AuthenticatePassword(handle, ref password, ref ack);
            if (lowLevelResult != 0)
            {
                ThrowException(handle, lowLevelResult);
                return -1;
            }

            return (int)ack;
        }
        /// <summary>
        /// Запись данные персонализации MifarePlus
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <param name="data"></param>
        internal static bool MifarePlusWritePersoExplicit(IntPtr handle, uint address, byte[] data)
        {
            byte valueType = 0x00;
            byte sectorNumber = 0x00;
            byte blockNumber = 0x00;

            /*
            if (address <= 0x007F)
            {
                sectorNumber = (byte)Math.Floor((float)address / 4);
                blockNumber = (byte)(address % 4);
            }
            else if (address <= 0x00FF)
            {
                sectorNumber = (byte)(32 + Math.Floor((float)(address - 0x80) / 16));
                blockNumber = (byte)((address - 0x80) % 16);
            }
            */
            if (address <= 0x00FF)
            {
                sectorNumber = AddressToSector((int)address);
                blockNumber = AddressToBlock((int)address);
            }
            else if (address == 0xB000)
                valueType = 0xB0;
            else if (address == 0xB001)
                valueType = 0xB1;
            else if (address == 0xB002)
                valueType = 0xB2;
            else if (address == 0xB003)
                valueType = 0xB3;
            else if ((0x4000 <= address) && (address <= 0x404F))
            {
                valueType = ((address & 0x00FF) % 2 == 0) ? (byte)0x4A : (byte)0x4B;
                sectorNumber = (byte)Math.Floor((float)(address & 0x00FF) / 2);
            }
            else if (address == 0x8000)
                valueType = 0x80;
            else if (address == 0x9000)
                valueType = 0x90;
            else if (address == 0x9001)
                valueType = 0x91;
            else if (address == 0x9002)
                valueType = 0x92;
            else if (address == 0x9003)
                valueType = 0x93;
            else if (address == 0x9004)
                valueType = 0x94;
            else if (address == 0xA000)
                valueType = 0xA0;
            else if (address == 0xA001)
                valueType = 0xA1;
            else if (address == 0xA080)
                valueType = 0xA2;
            else if (address == 0xA081)
                valueType = 0xA3;

            var pbData = Marshal.AllocHGlobal(16);
            Marshal.Copy(data, 0, pbData, 16);
            var lowLevelResult = CLSCRF_MifarePlus_WritePersoExplicit(handle, valueType, sectorNumber, blockNumber, pbData);
            Marshal.FreeHGlobal(pbData);
            if (lowLevelResult != 0)
            {
                ThrowException(handle, lowLevelResult);
                return false;
            }
            return true;
        }
        /// <summary>
        /// Завершение персонализации MifarePlus
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static bool MifarePlusCommitPerso(IntPtr handle)
        {
            uint Status = 0;

            Status = CLSCRF_MifarePlus_CommitPerso(handle);

            if (Status != 0)
                return false;

            return true;
        }
        /// <summary>
        /// Переинициализация T=CL ISO14443-4
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static void InitTCL()
        {
            _fBNBit = false;
        }
        /// <summary>
        /// Аутентификация MifarePlus EV1
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static bool MifarePlusEV1_AuthenticateA(IntPtr handle, byte sectorNumber, ushort keyFlashAddress)
        {
            uint Status = 0;

            byte[] PCDCap = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
            var pPCDCap = Marshal.AllocHGlobal(PCDCap.Length);
            Marshal.Copy(PCDCap, 0, new IntPtr(pPCDCap.ToInt64()), PCDCap.Length);
            var pRCOut = Marshal.AllocHGlobal(6);
            var pTCOut = Marshal.AllocHGlobal(6);
            Status = CLSCRF_MifarePlusEV1_Authenticate(handle, 0x03, 0x01, 0x01, 0x4A, sectorNumber, keyFlashAddress, 0x00, IntPtr.Zero, 0x06, pPCDCap, pRCOut, pTCOut);

            if (Status != 0)
                return false;

            return true;
        }
        /// <summary>
        /// Приемопередача T=CL ISO14443-4
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static uint TransceiveTCL(IntPtr handle, byte[] dataSend, ref byte[] dataRecv)
        {
            var pbSendBuffer = Marshal.AllocHGlobal(dataSend.Length + 2);
            Marshal.Copy(dataSend, 0, new IntPtr(pbSendBuffer.ToInt64() + 2), dataSend.Length);
            if (_fBNBit)
                Marshal.WriteByte(pbSendBuffer, 0x0B);
            else
                Marshal.WriteByte(pbSendBuffer, 0x0A);
            Marshal.WriteByte(new IntPtr(pbSendBuffer.ToInt64() + 1), 0x00);
            uint uiRecvLength = 1024;
            var pbRecvBuffer = Marshal.AllocHGlobal((int)uiRecvLength);
            uint lowLevelResult = CLSCRF_DirectIO_Card(handle, pbSendBuffer, (uint)dataSend.Length + 2, 1000, pbRecvBuffer, ref uiRecvLength);
            Marshal.FreeHGlobal(pbSendBuffer);
            _fBNBit = !_fBNBit;
            if (lowLevelResult == 0)
            {
                if (uiRecvLength > 2)
                {
                    dataRecv = new byte[uiRecvLength - 2];
                    Marshal.Copy(new IntPtr(pbRecvBuffer.ToInt64() + 2), dataRecv, 0, (int)uiRecvLength - 2);
                }
                Marshal.FreeHGlobal(pbRecvBuffer);
            }
            else
            {
                Marshal.FreeHGlobal(pbRecvBuffer);
                //ThrowException(handle, lowLevelResult);
            }

            return lowLevelResult;
        }

        /// <summary>
        /// Найти все карты типа ISO15693
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static byte[] FindAllTags15693(IntPtr handle)
        {
            var pbData = Marshal.AllocHGlobal(1024);
            uint dwDataLength = 1024;
            var aia_r = CLSCRF_FindAllTags_15693(handle, 0x00, 0x00, pbData, ref dwDataLength);
            byte[] result;
            if (aia_r == 0)
            {
                result = new byte[dwDataLength];
                Marshal.Copy(pbData, result, 0, (int)dwDataLength);
            }
            else
            {
                result = null;
            }
            Marshal.FreeHGlobal(pbData);
            return result;
        }
        /// <summary>
        /// Считать несколько блоков из карт стандарта ISO15693
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static byte[] ReadMultipleBlocksISO15693(IntPtr handle, byte[] UID, byte ucFirstBlockNumber, byte ucNumberOfBlocks)
        {
            var pbBlockSecurityStatus = Marshal.AllocHGlobal(1024);
            var pbData = Marshal.AllocHGlobal(1024);
            var pbUID = Marshal.AllocHGlobal(10);
            byte ucOutFlags = 0;
            byte ucErrorCode = 0;
            Marshal.Copy(UID, 0, pbUID, UID.Length);
            var aia_r = CLSCRF_ReadMultipleBlocks_15693(handle,
                                                        0x62,
                                                        0x23,
                                                        pbUID,
                                                        ucFirstBlockNumber,
                                                        ref ucNumberOfBlocks,
                                                        ref ucOutFlags,
                                                        pbBlockSecurityStatus,
                                                        pbData,
                                                        ref ucErrorCode);
            byte[] result;
            if ((aia_r == 0) && (ucErrorCode == 0x00))
            {
                result = new byte[ucNumberOfBlocks * 4];
                Marshal.Copy(pbData, result, 0, (int)ucNumberOfBlocks * 4);
            }
            else
            {
                result = null;
            }
            Marshal.FreeHGlobal(pbBlockSecurityStatus);
            Marshal.FreeHGlobal(pbData);
            Marshal.FreeHGlobal(pbUID);
            return result;
        }
        /// <summary>
        /// Записать несколько блоков на карту стандарта ISO15693
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static void WriteMultipleBlocksISO15693(IntPtr handle, byte[] UID, byte ucFirstBlockNumber, byte ucNumberOfBlocks, byte[] Data)
        {
            var pbData = Marshal.AllocHGlobal(1024);
            var pbUID = Marshal.AllocHGlobal(10);
            byte ucInFlags = 0;
            byte ucOutFlags = 0;
            byte ucErrorCode = 0;
            Marshal.Copy(UID, 0, pbUID, UID.Length);
            Marshal.Copy(Data, 0, pbData, ucNumberOfBlocks * 4);
            /*
            var aia_r = CLSCRF_WriteMultipleBlocks_15693(handle,
                                                        0x22,
                                                        0x24,
                                                        pbUID,
                                                        ucFirstBlockNumber,
                                                        ucNumberOfBlocks,
                                                        pbData,
                                                        ref ucOutFlags,
                                                        ref ucErrorCode);
            */

            if (UID[6] == 0x07)
                ucInFlags = 0x62;
            else
                ucInFlags = 0x22;

            for (byte i = 0; i < ucNumberOfBlocks; i++)
            {
                var aia_r = CLSCRF_WriteSingleBlock_15693(handle,
                                                            ucInFlags,
                                                            0x21,
                                                            pbUID,
                                                            (byte)(ucFirstBlockNumber + i),
                                                            new IntPtr(pbData.ToInt64() + i * 4),
                                                            ref ucOutFlags,
                                                            ref ucErrorCode);
                if ((aia_r != 0) || (ucErrorCode != 0x00))
                {
                    Marshal.FreeHGlobal(pbData);
                    Marshal.FreeHGlobal(pbUID);
                    ThrowException(handle, aia_r);
                }
            }
            Marshal.FreeHGlobal(pbData);
            Marshal.FreeHGlobal(pbUID);
        }
        /// <summary>
        /// Сменить текущий холдер SAM-модуля
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static bool SAMSetHolder(IntPtr handle, byte holder)
        {
            var lowLevelResult = CLSCRF_SAM_SetCurrentHolder(handle, holder);
            if (lowLevelResult != 0)
            {
                ThrowException(handle, lowLevelResult);
                return false;
            }

            return true;
        }
        /// <summary>
        /// Считать версию SAM-модуля
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static byte[] SAMGetVersion(IntPtr handle, byte logicalChannel)
        {
            var pbVersion = Marshal.AllocHGlobal(256);
            var result = new byte[31];
            byte SW1 = 0x00;
            byte SW2 = 0x00;
            var lowLevelResult = CLSCRF_SAM_GetVersion(handle, logicalChannel, pbVersion, ref SW1, ref SW2);
            if (lowLevelResult == 0)
            {
                Marshal.Copy(pbVersion, result, 0, 31);
                Marshal.FreeHGlobal(pbVersion);
            }
            else
            {
                Marshal.FreeHGlobal(pbVersion);
                result = null;
                ThrowException(handle, lowLevelResult);
            }

            return result;
        }
        /// <summary>
        /// Изменить ключ в SAM-модуле
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="keyType"></param>
        /// <param name="UID"></param>
        /// <param name="sector"></param>
        /// <returns></returns>
        public static bool SAMChangeKeyEntryPICC(IntPtr handle, byte logicalChannel, byte keyKind, byte keyNo, byte keyPos, byte keyVer, byte[] key)
        {
            byte keyVersionA = 0x00;
            byte keyVersionB = 0x00;
            byte keyVersionC = 0x00;
            uint desFireAID = 0;
            byte desFireKeyNo = 0x00;
            byte keyNoCEK = 0x00;
            byte keyVerCEK = 0x00;
            byte refNoKUC = 0x00;
            ushort settings = 0x0000;
            byte extSettings = 0x00;
            byte SW1 = 0x00;
            byte SW2 = 0x00;

            //byte sector = AddressToSector(address);
            //var pbUID = Marshal.AllocHGlobal(UID.Length);
            //Marshal.Copy(UID, UID.Length - 4, pbUID, 4);
            var lowLevelResult = CLSCRF_SAM_GetKeyEntry(
                handle, 
                logicalChannel, 
                keyKind, 
                keyNo, 
                ref keyVersionA, 
                ref keyVersionB, 
                ref keyVersionC, 
                ref desFireAID, 
                ref desFireKeyNo,
                ref keyNoCEK,
                ref keyVerCEK,
                ref refNoKUC,
                ref settings,
                ref extSettings,
                ref SW1, 
                ref SW2);
            //Marshal.FreeHGlobal(pbUID);
            if (lowLevelResult != 0)
            {
                ThrowException(handle, lowLevelResult);
                return false;
            }

            keyVersionA = keyVer;// 0x00;
            keyVersionB = keyVer;// 0x01;
            keyVersionC = keyVer;// 0x02;

            settings = (ushort)(settings & 0xFDFF); //активация ключа

            extSettings = (byte)(extSettings & 0xF8 | 0x01); //тип ключа - PICC

            byte programmingMask = (byte)(0xF8 | (0x01 << keyPos)); //выбор позиции ключа: 0,1,2

            byte[] SAMUID = new byte[7];
            var pbSAM_UID = Marshal.AllocHGlobal(SAMUID.Length);
            Marshal.Copy(SAMUID, 0, pbSAM_UID, SAMUID.Length);
            var pbKeyA = Marshal.AllocHGlobal(16);
            Marshal.Copy(key, 0, pbKeyA, SAMUID.Length);
            var pbKeyB = Marshal.AllocHGlobal(16);
            Marshal.Copy(key, 0, pbKeyB, SAMUID.Length);
            var pbKeyC = Marshal.AllocHGlobal(16);
            Marshal.Copy(key, 0, pbKeyC, SAMUID.Length);
            lowLevelResult = CLSCRF_SAM_ChangeKeyEntry(
                handle, 
                logicalChannel,
                keyNo,
                keyKind,
                pbKeyA,
                pbKeyB,
                pbKeyC,
                desFireAID,
                desFireKeyNo,
                keyNoCEK,
                keyVerCEK,
                refNoKUC,
                ref settings,
                keyVersionA,
                keyVersionB,
                keyVersionC,
                ref extSettings,
                0x00000001,
                0x00000000,
                pbSAM_UID,
                ref programmingMask,
                ref SW1, 
                ref SW2
                );
            Marshal.FreeHGlobal(pbKeyA);
            Marshal.FreeHGlobal(pbKeyB);
            Marshal.FreeHGlobal(pbKeyC);
            Marshal.FreeHGlobal(pbSAM_UID);

            if (lowLevelResult != 0)
            {
                ThrowException(handle, lowLevelResult);
                return false;
            }

            return true;
        }
        /// <summary>
        /// Изменить ключи Mifare Standard в SAM-модуле
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="keyType"></param>
        /// <param name="UID"></param>
        /// <param name="sector"></param>
        /// <returns></returns>
        public static bool SAMChangeKeyEntryMifareStandard(IntPtr handle, byte logicalChannel, byte keyNo, byte keyPos, byte keyVer, byte[] keyA, byte[] keyB)
        {
            byte[] key = new byte[16];
            keyA.CopyTo(key, 0);
            keyB.CopyTo(key, 8);
            return SAMChangeKeyEntryPICC(handle, logicalChannel, 0x02, keyNo, keyPos, keyVer, key);
        }
        /// <summary>
        /// Авторизоваться к сектору Mifare Classic через SAM
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="keyType"></param>
        /// <param name="UID"></param>
        /// <param name="sector"></param>
        /// <returns></returns>
        public static bool SAMMifareStandardAuth(IntPtr handle, byte logicalChannel, byte authType, byte keyType, byte keyNo, byte keyVer, byte[] UID, int address)
        {
            var result = false;
            byte SW1 = 0x00;
            byte SW2 = 0x00;
            byte sector = AddressToSector(address);
            var pbUID = Marshal.AllocHGlobal(UID.Length);
            Marshal.Copy(UID, UID.Length - 4, pbUID, 4);
            var lowLevelResult = CLSCRF_SAM_MifareAuthenticate(handle, logicalChannel, authType, pbUID, keyNo, keyVer, keyType, sector, ref SW1, ref SW2);
            Marshal.FreeHGlobal(pbUID);
            if (lowLevelResult == 0)
            {
                result = true;
            }
            else
            {
                ThrowException(handle, lowLevelResult);
            }
            return result;
        }

        public static byte AddressToSector(int address)
        {
            if (address <= 0x007F)
                return (byte)Math.Floor((float)address / 4);
            else if (address <= 0x00FF)
                return (byte)(32 + Math.Floor((float)(address - 0x80) / 16));
            return 0xFF;
        }

        public static byte AddressToBlock(int address)
        {
            if (address <= 0x007F)
                return (byte)(address % 4);
            else if (address <= 0x00FF)
                return (byte)((address - 0x80) % 16);
            return 0xFF;
        }


    }
}
