﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
//using System.Threading.Tasks;

namespace MifareSAM
{
    class Program
    {
        static IntPtr _handle;
        static byte[] _uid;

        static void Main(string[] args)
        {
            bool fRes = false;

            _uid = new byte[10];
            _handle = new IntPtr();

            Clscrfl_SAM.Create(ref _handle);
            Clscrfl_SAM.OpenUSB(_handle);
            /*Clscrfl_SAM.Blink(_handle);
            Clscrfl_SAM.Sound(_handle);*/

            //Clscrfl_SAM.ReaderOn(_handle);
            //_uid = Clscrfl_SAM.ConnectToCard(_handle);
            //Clscrfl_SAM.LoadKey(_handle, 0, 0x60, new byte[] { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF });
            //Clscrfl_SAM.Auth(_handle, 0x60, _uid, 0);

            /*byte[] stateBytes = Clscrfl.GetStateBytes(handle);
            if (stateBytes[0] != 0x40)
            {
                Clscrfl.SetRFMode15693(handle);
            }
            byte[] Data = Clscrfl.FindAllTags15693(handle);
            byte[] UID = new byte[8];
            for (int i = 0; i < UID.Length; i++)
                UID[i] = Data[i + 4];
            Data = Clscrfl.ReadMultipleBlocksISO15693(handle, UID, 0, 28);

            Data[0] = 0x31;
            Clscrfl.WriteMultipleBlocksISO15693(handle, UID, 0, 28, Data);
            Data = Clscrfl.ReadMultipleBlocksISO15693(handle, UID, 0, 28);*/

            fRes = RfOff();
            fRes = RfOn();

            byte[] data = new byte[256];

            /*
            // Ultralight EV1
            _uid = Clscrfl_SAM.ConnectToCard(_handle);

            if (_uid == null)
            {
                System.Console.Write("ConnectToCard: _uid= {0:d}:\n", _uid);
                return;
            }

            fRes = GetVersion_ULEV1();
            int ack = Ev1AuthByPassword(0xFFFFFFFF);//0x00000000);
            fRes = ReadCounter_ULEV1(0, out data);
            fRes = IncrementCounter_ULEV1(0, 3);
            fRes = ReadCounter_ULEV1(0, out data);
            //fRes = ReadPageULC(7, out data);
            //fRes = WritePageULC(7, data);
            //fRes = ReadPageULC(7, out data);
            */

            /*
            // Mifare Plus SL0
            _uid = Clscrfl_SAM.ConnectToCard(_handle);
            fRes = RequestATS();
            fRes = WritePersonalize(0x0005, data);
            //fRes = CommitPersonalize();
            */

            // SAM Mifare Classic / Plus SL1
            _uid = Clscrfl_SAM.ConnectToCard(_handle);

            /*
            // Test MFP EV1
            {
                fRes = RequestATS();
                fRes = Clscrfl_SAM.MifarePlusEV1_AuthenticateA(_handle, 0x00, 0x0000);
            }
            */


            fRes = AuthenticateExtKey(2, new byte[6] { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF }, _uid, true);
            fRes = ReadBlock(2, out data);
            fRes = WriteBlock(2, data);
            fRes = ReadBlock(2, out data);

            fRes = Halt();

            // SAM EV1
            fRes = SwitchSAM(0);
            if (!fRes)
                fRes = SwitchSAM(1);
            if (!fRes)
                fRes = SwitchSAM(2);
            if (!fRes)
                fRes = SwitchSAM(3);
            byte[] version = new byte[256];
            fRes = GetCurrentSamUID(out version);
            fRes = LoadKey(new byte[] { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF }, 10, 0, 0);

            fRes = PingCard();

            fRes = AuthenticateSAM(2, 10, 0, true);
            fRes = ReadBlock(2, out data);
            fRes = WriteBlock(2, data);
            fRes = ReadBlock(2, out data);

            fRes = ResetReader();
            fRes = RfOn();

            fRes = ReadSector(2, 10, 0, out data, true, true, true);
            fRes = WriteSector(2, 10, 0, data, true, true);

        }

        // WAKE UP
        public static bool PingCard()
        {
            bool fRes = true;

            byte[] cmd = { 0x09, 0x00, 0x00 };

            fRes = Clscrfl_SAM.WakeupCard14443A(_handle, _uid);

            return fRes;
        }


        public static bool ReadPageULC(int page, out byte[] data)
        {
            bool fRes = true;

            byte[] cmd = { 0x21, 0x00 };

            data = Clscrfl_SAM.MifareUltralightRead(_handle, (byte)page);

            if (data == null)
                fRes = false;

            return fRes;
        }

        public static bool WritePageULC(int page, byte[] data)
        {
            bool fRes = true;

            byte[] cmd = { 0x22, 0x00, 0x00, 0x00, 0x00, 0x00 };

            fRes = Clscrfl_SAM.MifareUltralightWrite(_handle, (byte)page, data);

            return fRes;
        }

        // Сброс микросхемы CLRC633
        public static bool ResetReader()
        {
            bool fRes = true;

            byte[] cmd = { 0x1F };

            fRes = Clscrfl_SAM.ReaderOff(_handle);
            if (!fRes)
                return fRes;

            fRes = fRes && Clscrfl_SAM.ReaderOn(_handle);

            return fRes;
        }

        /*
        // Не делаем?
        /// <summary>
        /// Установить режим хранения ключей
        /// </summary>
        /// <param name="mode">Хранилище ключей 0 - SAM AV2, 1 - SRAM</param>
        /// <returns></returns>
        public bool SetStorgeKeyMode(byte mode)
        {
            bool fRes = true;

            byte[] cmd = { 0xEF, 0x00, 0x00 };

            return fRes;
        }

        // Не делаем?
        public bool WriteKeysToFlash()
        {
            bool fRes = true;

            byte[] cmd = { 0xEF, 0x01 };

            return fRes;
        }

        // Не делаем?
        public bool WriteKeysToSRAM()
        {
            bool fRes = true;

            byte[] cmd = { 0xEF, 0x02 };

            return fRes;
        }
        
        // Под вопросом
        public string GetVersion()
        {
            string sRes = "";

            byte[] cmd = { 0x02, 0x01, 0x16, 0x17 }; //$02$01$16$17

            return sRes;
        }
        */

        public static bool RequestATS()
        {
            bool fRes = true;

            //byte[] cmd = { 0x1C, 0x01, 0x01 };

            fRes = Clscrfl_SAM.RequestAnswerToSelect(_handle);

            return fRes;
        }

        public static bool WritePersonalize(int address, byte[] data)
        {
            bool fRes = true;

            byte[] cmd = { 0x1E, (byte)(address & 0xFF), (byte)((address & 0xFF00) >> 8) };

            fRes = Clscrfl_SAM.MifarePlusWritePersoExplicit(_handle, (uint)address, data);

            return fRes;
        }

        public static bool CommitPersonalize()
        {
            bool fRes = true;

            byte[] cmd = { 0x1D };

            fRes = Clscrfl_SAM.MifarePlusCommitPerso(_handle);

            return fRes;
        }

        // Включение поля (микросхему включать автоматом)
        public static bool RfOn()
        {
            bool fRes = true;

            byte[] cmd = { 0x02 };

            fRes = Clscrfl_SAM.ReaderOn(_handle);

            if (!fRes)
                return fRes;

            fRes = Clscrfl_SAM.ReaderRfOn(_handle);

            return fRes;
        }

        // Выключает радиополе считывателя и светодиоды (микросхема считывателя остается включенной).
        public static bool RfOff()
        {
            bool fRes = true;

            byte[] cmd = { 0xFF };

            fRes = Clscrfl_SAM.ReaderOn(_handle);

            if (!fRes)
                return fRes;

            fRes = Clscrfl_SAM.ReaderRfOff(_handle);

            return fRes;
        }

        // Возвращает ответ SAM GetVersion
        public static bool GetCurrentSamUID(out byte[] version)
        {
            bool fRes = true;

            byte[] cmd = { 0x30 };

            version = Clscrfl_SAM.SAMGetVersion(_handle, 0x00);

            if (version == null)
                fRes = false;

            return fRes;
        }

        // Аутентификация CRYPTO1
        public static bool AuthenticateSAM(int block, int keyIndex, int ver, bool keyA = true)
        {
            bool fRes = true;

            byte[] cmd = { 0x32, 0x00, 0x00, 0x00, 0x00 };

            fRes = Clscrfl_SAM.SAMMifareStandardAuth(_handle, 0x00, 0x01, keyA ? (byte)0x0A : (byte)0x0B, (byte)keyIndex, (byte)ver, _uid, block);

            return fRes;
        }


        public static bool AuthenticateExtKey(int block, byte[] extKey, byte[] uid, bool keyA = true)
        {
            bool fRes = true;

            byte[] cmd = { 0x0C, 0x00, 0x00 };

            fRes = Clscrfl_SAM.MifareStandardLoadKeyAddress(_handle, block, keyA ? (byte)0x60 : (byte)0x61, extKey);

            if (!fRes)
                return fRes;

            fRes = Clscrfl_SAM.MifareStandardAuthAddress(_handle, keyA ? (byte)0x60 : (byte)0x61, uid, block);

            return fRes;
        }

        /*
        // Нужно описание структуры BaseDriverCard
        public bool ActivationCard(BaseDriverCard card)
        {
            byte[] cmd = { 0x09, 0x00, 0x00 };

            _uid = Clscrfl_SAM.ConnectToCard14443A(_handle);

            return (_uid != null);
        }
        */

        public static bool ReadBlock(int block, out byte[] data)
        {
            byte[] cmd = { 0x0D, 0x00, 0x00, 0x00 };

            data = Clscrfl_SAM.MifareStandardReadAddress(_handle, block);

            return (data != null);
        }

        // Чтение начиная с указанного блока
        public static bool ReadSector(int block, int keyIndex, int ver, out byte[] data, bool auth = false, bool keyA = true, bool readTrailer = false)
        {
            bool fRes = true;

            byte[] cmd = { 0x33, (byte)(readTrailer ? 0x1D : 0x0D), 0x00, 0x00, 0x00, 0x00, 0x00 };

            if (auth)
            {
                fRes = AuthenticateSAM(block, keyIndex, ver, keyA);
                if (!fRes)
                {
                    data = null;
                    return fRes;
                }
            }

            byte sectorNumber = Clscrfl_SAM.AddressToSector(block);
            byte blockNumber = Clscrfl_SAM.AddressToBlock(block);

            byte[] tmpData = new byte[64];

            while (blockNumber < 3 + (readTrailer?1:0))
            {
                byte[] tmpBlockData = Clscrfl_SAM.MifareStandardRead(_handle, sectorNumber, blockNumber);
                if (tmpBlockData == null)
                {
                    data = null;
                    return false;
                }
                tmpBlockData.CopyTo(tmpData, 16*blockNumber);
                blockNumber++;
            }

            data = tmpData;

            return fRes;
        }

        public static bool WriteBlock(int page, byte[] data)
        {
            bool fRes = true;

            byte[] cmd = { 0x0E, 0xA0, 0x00, 0x10 };

            fRes = Clscrfl_SAM.MifareStandardWriteAddress(_handle, page, data);

            return fRes;
        }

        /// <summary>
        /// Запись сектора
        /// </summary>
        /// <param name="block"></param>
        /// <param name="keyIndex"></param>
        /// <param name="out_data">данные для записи - 48 байт</param>
        /// <param name="auth"></param>
        /// <param name="keyA"></param>
        public static bool WriteSector(int block, int keyIndex, int ver, byte[] data, bool auth = false, bool keyA = true)
        {
            bool fRes = true;

            byte[] cmd = { 0x33, 0x0E, 0x00, 0x00, 0x00, 0x00, 0x00 };

            if (auth)
            {
                fRes = AuthenticateSAM(block, keyIndex, ver, keyA);
                if (!fRes)
                    return fRes;
            }

            byte sectorNumber = Clscrfl_SAM.AddressToSector(block);
            byte blockNumber = Clscrfl_SAM.AddressToBlock(block);

            byte[] tmpBlockData = new byte[16];

            while (blockNumber < 3)
            {
                Array.Copy(data, 16*blockNumber, tmpBlockData, 0, 16);
                fRes = Clscrfl_SAM.MifareStandardWrite(_handle, sectorNumber, blockNumber, tmpBlockData);
                if (!fRes)
                    return fRes;
                blockNumber++;
            }

            return fRes;
        }

        // ИСПОЛЬЗОВАТЬ ПЕРВЫЙ СЧЕТЧИК ~ 41 стр. данных
        // 1б код+3б знач
        public static bool ReadCounter_ULEV1(int counter, out byte[] data)
        {
            bool fRes = true;

            byte[] cmd = { 0x5F, 0x00 };

            uint value = 0;

            fRes = Clscrfl_SAM.MifareUltralightEV1ReadCounter(_handle, counter, ref value);

            if (!fRes)
            {
                data = null;
                return fRes;
            }

            byte[] tmpData = new byte[3];
            tmpData[0] = (byte)(value & 0x000000FF);
            tmpData[1] = (byte)((value >> 8) & 0x000000FF);
            tmpData[2] = (byte)((value >> 16) & 0x000000FF);

            data = tmpData;

            return fRes;
        }

        // Две операции в итоге будет - чтение, приращение, запись
        public static bool IncrementCounter_ULEV1(int counter, uint incValue)
        {
            bool fRes = true;

            byte[] cmd = { 0x60, 0x00, 0x00, 0x00, 0x00 };

            fRes = Clscrfl_SAM.MifareUltralightEV1IncrementCounter(_handle, counter, incValue);

            return fRes;
        }

        // По данной функции нам необходимо получить true, если ошибки не возникло
        public static bool GetVersion_ULEV1()
        {
            byte[] cmd = { 0x51 };

            byte[] version = Clscrfl_SAM.MifareUltralightEV1GetVersion(_handle);

            return (version != null);
        }

        // Нумерация слота от 0
        // Только AV2 (преверка через GetVersion)
        public static bool SwitchSAM(byte slot_num)
        {
            bool fRes = true;

            byte[] cmd = { 0x27, 0x00 };

            fRes = Clscrfl_SAM.SAMSetHolder(_handle, slot_num);

            if (!fRes)
                return fRes;

            byte[] version = Clscrfl_SAM.SAMGetVersion(_handle, 0x00);

            if (version == null)
                return false;

            if (version.Length != 31)
                return false;

            if (version[30] != 0xA2)
                return false;

            return fRes;
        }

        // Формат: 12 байт = A + B
        /// <summary>
        /// Запись ключей в SAM модуль
        /// </summary>
        /// <param name="key"></param>
        /// <param name="index"></param>
        /// <param name="pos"></param>
        /// <param name="ver"></param>
        /// <returns></returns>
        public static bool LoadKey(byte[] key, int index, int pos = 0, int ver = 0)
        {
            bool fRes = true;

            byte[] cmd = { 0x31, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };

            byte[] keyA = new byte[6];
            byte[] keyB = new byte[6];

            Array.Copy(key, 0, keyA, 0, 6);
            Array.Copy(key, 6, keyB, 0, 6);

            fRes = Clscrfl_SAM.SAMChangeKeyEntryMifareStandard(_handle, 0x00, (byte)index, (byte)pos, (byte)ver, keyA, keyB);

            return fRes;
        }

        /*
        // Работает с SAM модулем
        // Для этой команды должна быть также команда 0xDB, а ее в списке нет
        public bool ActivateKey(byte key, byte version)
        {
            bool fRes = true;

            byte[] cmd = { 0xDC, key, version };

            return fRes;
        }

        // Прислали, а говорите, что не нужна
        public bool SignBytesInBuffer(byte bytesInBufferLength, out byte[] data)
        {
            bool fRes = true;

            byte[] cmd = { 0xCD, 16, bytesInBufferLength };

            data = null;

            return fRes;
        }

        public bool WriteToBuffer(byte[] bytes)
        {
            bool fRes = true;

            var cmd = new List<byte> { 0xC4, 0, (byte)bytes.Length };

            return fRes;
        }
        */

        public static bool Halt()
        {
            bool fRes = true;

            byte[] cmd = { 0x13 };

            fRes = Clscrfl_SAM.HaltCard14443A(_handle);

            return fRes;
        }

        public static int Ev1AuthByPassword(uint password)
        {
            int iRes = 0;

            byte[] cmd = { 0x61, 0x00, 0x00, 0x00, 0x00 };

            iRes = Clscrfl_SAM.MifareUltralightEV1Authenticate(_handle, password);

            return iRes;
        }

       
    }
}
