#include "StdAfx.h"

#include "Clscrfl.h"

extern "C" LONG __attribute__((visibility("default"))) CLSCRF_DECL
CLSCRF_Create(IN OUT LPVOID* ppReader)
{
	LONG Status = SCARD_S_SUCCESS;

	//ZeroMemory(&m_DF_SettingsGlobal[*ppReader], sizeof(m_DF_SettingsGlobal[*ppReader]));
	//ZeroMemory(&m_DF_SettingsGlobal[*ppReader].ByIOAddress[0], sizeof(m_DF_SettingsGlobal[*ppReader].ByIOAddress[0]));
	//ZeroMemory(&m_CryptoSettingsGlobal[*ppReader], sizeof(m_CryptoSettingsGlobal[*ppReader]));
	//ZeroMemory(&m_CryptoSettingsGlobal[*ppReader].ByIOAddress[0], sizeof(m_CryptoSettingsGlobal[*ppReader].ByIOAddress[0]));

	CTransfer* pTr = new CTransfer;

	if (pTr)
	{
		pTr->m_ComPort.SetCallback(CommError, CommRX, pTr);
		*ppReader = pTr;
	}
	else
	{
		*ppReader = NULL;
		Status = SCARD_E_READER_UNAVAILABLE;    // not created
	}

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_Destroy(IN OUT LPVOID* ppReader)
{
	LONG Status = SCARD_S_SUCCESS;

	if (*ppReader)
	{
		CTransfer* pTr = (CTransfer*)*ppReader;

		//pTr->Close();

		//delete[] pTr;

		delete pTr;
		
		*ppReader = NULL;
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_Open(IN LPVOID pReader,
IN DWORD  dwPortNumber,
IN DWORD  dwBaudrate,
IN DWORD  dwLogFile)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader == NULL)
		Status = SCARD_E_READER_UNAVAILABLE;

	if (Status == SCARD_S_SUCCESS)
		switch (dwBaudrate)
	{
		case 9600:
		case 14400:
		case 19200:
		case 38400:
		case 57600:
		case 115200:
		case 1500000:
			break;

		default:
			Status = SCARD_E_INVALID_PARAMETER;
	}

	if (Status == SCARD_S_SUCCESS)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		DWORD Index = dwPortNumber;
		DWORD Br = dwBaudrate;
		if (dwPortNumber)
			Index--;
		else
			Br = 0;

		if (!pTr->Open(dwLogFile, Index, Br))
			Status = SCARD_F_COMM_ERROR;
	}

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_OpenRS(IN LPVOID pReader,
IN DWORD  dwIndex,
IN DWORD  dwBaudrate,
IN DWORD  dwLogFile)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader == NULL)
		Status = SCARD_E_READER_UNAVAILABLE;

	if (Status == SCARD_S_SUCCESS)
		switch (dwBaudrate)
	{
		case 9600:
		case 14400:
		case 19200:
		case 38400:
		case 57600:
		case 115200:
		case 250000:
		case 750000:
		case 1500000:
			break;

		default:
			Status = SCARD_E_INVALID_PARAMETER;
	}

	if (Status == SCARD_S_SUCCESS)
	{
		CTransfer* pTr = (CTransfer*)pReader;

		//if (!pTr->Open(0x00000001, dwIndex, dwBaudrate))
		if (!pTr->Open(dwLogFile, dwIndex, dwBaudrate))
			Status = SCARD_F_COMM_ERROR;
	}

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_OpenUSB(IN LPVOID pReader,
IN DWORD  dwIndex,
IN DWORD  dwLogFile)
{
	LONG Status = SCARD_S_SUCCESS;
	//CRC32* ccc = new CRC32(); char myArray[] = { 0x00, 0x11, 0x22, 0x33, 0x44 };  ccc->Hash(myArray, 5); int res = ccc->Get();
	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;

		//if (!pTr->Open(0x00000001, dwIndex, 0))
		if (!pTr->Open(dwLogFile, dwIndex, 0))
			Status = SCARD_F_COMM_ERROR;
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

/*CLSCRF_API LONG CLSCRF_DECL
CLSCRF_OpenETH(IN LPVOID pReader,
IN DWORD  dwPort,
IN PCHAR  szIP,
IN DWORD  dwLogFile)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;

		if (!pTr->Open(dwLogFile, dwPort, 0, szIP))
			Status = SCARD_F_COMM_ERROR;
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_OpenPCSC(IN LPVOID pReader,
IN PCHAR  szName,
IN DWORD  dwLogFile)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;

		if (!pTr->Open(dwLogFile, 0, 0, NULL, szName))
			Status = SCARD_F_COMM_ERROR;
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}*/

CLSCRF_API bool CLSCRF_DECL
CLSCRF_IsOpened(IN LPVOID pReader)
{
	bool Result = false;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;

		if (pTr->IsOpened())
			Result = true;
	}

	return Result;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_Close(IN LPVOID pReader)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;

		if (!pTr->Close())
			Status = SCARD_F_COMM_ERROR;
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_GetIOTimeout(IN     LPVOID  pReader,
OUT LPDWORD pdwTimeout)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		*pdwTimeout = pTr->GetTimeout();
	}
	else
	{
		*pdwTimeout = DEFAULT_IO_TIMEOUT;
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_SetIOTimeout(IN LPVOID pReader,
IN DWORD  dwTimeout)
{
	LONG Status = SCARD_S_SUCCESS;
	DWORD Timeout = dwTimeout;

	if (pReader == NULL)
		Status = SCARD_E_READER_UNAVAILABLE;

	if (Status == SCARD_S_SUCCESS)
	{
		if (Timeout)
		{
			if (Timeout < MINIMUM_IO_TIMEOUT)
				Status = SCARD_E_INVALID_PARAMETER;
			if (Timeout > MAXIMUM_IO_TIMEOUT)
				Status = SCARD_E_INVALID_PARAMETER;
		}
		else
			Timeout = DEFAULT_IO_TIMEOUT;
	}

	if (Status == SCARD_S_SUCCESS)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->SetTimeout(Timeout);
	}

	return Status;
}

BYTE GetLastInternalError(LPVOID pReader)
{
	BYTE bError;
	CTransfer* pTr = (CTransfer*)pReader;
	DWORD Size = 1;
	pTr->m_RcBuf.GetBulk(0, &bError, &Size);

	return bError;
}

