#include "StdAfx.h"

#include "Clscrfl.h"

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifareUltralight_Read(IN     LPVOID pReader,
IN     BYTE   bPage,
OUT LPBYTE pbRecvBuffer)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0x19);
		pTr->m_TrBuf.AddByte(bPage);

		DWORD Size;
		Status = pTr->SingleTransceive();

		if (Status == SCARD_S_SUCCESS)
		{
			Size = 16;
			if (!pTr->m_RcBuf.GetBulk(1, pbRecvBuffer, &Size))
				Status = SCARD_E_COMM_DATA_LOST;
		}
	}
	else
	{
		ZeroMemory(pbRecvBuffer, 16);
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifareUltralight_Write(IN LPVOID pReader,
IN BYTE   bPage,
IN LPBYTE pbSendBuffer)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0x1e);
		pTr->m_TrBuf.AddByte(bPage);
		pTr->m_TrBuf.AddBulk(pbSendBuffer, 4);

		Status = pTr->SingleTransceive();
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifareUltralightC_WriteKey(IN LPVOID pReader,
IN DWORD  dwKeyFlashAddress)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0x2C);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwKeyFlashAddress, 2);

		Status = pTr->SingleTransceive();
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_MifareUltralightC_Authenticate(IN LPVOID pReader,
IN DWORD  dwKeyFlashAddress)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0x2D);
		pTr->m_TrBuf.AddBulk((PBYTE)&dwKeyFlashAddress, 2);

		Status = pTr->SingleTransceive();
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}
