#include "StdAfx.h"

#include "Clscrfl.h"

/*
CLSCRF_API LONG CLSCRF_DECL
CLSCRF_TDA8029_APDU(IN     LPVOID  pReader,
IN     LPCBYTE pbSendBuffer,
IN     DWORD   dwSendLength,
OUT LPBYTE  pbRecvBuffer,
IN OUT LPDWORD pdwRecvLength)
{
	//60 00 07 00 00 A4 00 00 02 4F 00 8E
	//60 00 02 00 90 00 F2
	BYTE pExSendBuffer[256] = { 0 };
	DWORD dwExSendLength = 0;
	BYTE pExRecvBuffer[256] = { 0 };
	DWORD dwExRecvLength = sizeof(pExRecvBuffer);

	LONG Status = SCARD_S_SUCCESS;

	if (dwSendLength == 0)
	{
		*pdwRecvLength = 0;
		Status = SCARD_E_INVALID_PARAMETER;
	}
	else if (dwSendLength > 250)
	{
		*pdwRecvLength = 0;
		Status = SCARD_E_INVALID_PARAMETER;
	}
	else if (pReader)
	{
		pExSendBuffer[0] = 0x60;
		pExSendBuffer[1] = 0x00;
		pExSendBuffer[2] = dwSendLength;
		pExSendBuffer[3] = 0x00;
		memcpy(&pExSendBuffer[4], pbSendBuffer, dwSendLength);
		pExSendBuffer[4 + dwSendLength] = 0x00;

		Status = CLSCRF_TDA8029_Exchange(pReader, pExSendBuffer, dwExSendLength, pExRecvBuffer, &dwExRecvLength);

		DWORD Size = dwExRecvLength;

		if (Size <= 5)  
		{
			*pdwRecvLength = 0;
			if (Status == SCARD_S_SUCCESS)
				return SCARD_E_COMM_DATA_LOST;    // 0x8010002F
		}
		else
		{
			if (pExRecvBuffer[0] == 0xE0)
			{
				CTransfer* pTr = (CTransfer*)pReader;
				pTr->m_RcBuf.Clear();
				pTr->m_RcBuf.AddByte(pExRecvBuffer[3]);
				return SCARD_F_INTERNAL_ERROR;
			}
			if (pExRecvBuffer[0] != 0x60)		{
				*pdwRecvLength = 0;
				if (Status == SCARD_S_SUCCESS)
					return SCARD_E_COMM_DATA_LOST;    // 0x8010002F
			}
			Size = 2;
			*pdwRecvLength = pExRecvBuffer[1] * 256 + pExRecvBuffer[2];

			if (*pdwRecvLength > BufSize)
			{
				*pdwRecvLength = BufSize;
				if (Status == SCARD_S_SUCCESS)
					Status = SCARD_E_INSUFFICIENT_BUFFER;
			}

			if ((Size = *pdwRecvLength) > 0)
				if (!pTr->m_RcBuf.GetBulk(3, pbRecvBuffer, pdwRecvLength))
				{
					if (Status == SCARD_S_SUCCESS)
						Status = SCARD_E_COMM_DATA_LOST;
				}
		}
	}
	else
	{
		*pdwRecvLength = 0;
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_TDA8029_Exchange(IN     LPVOID  pReader,
IN     LPCBYTE pbSendBuffer,
IN     DWORD   dwSendLength,
OUT LPBYTE  pbRecvBuffer,
IN OUT LPDWORD pdwRecvLength)
{
	LONG Status = SCARD_S_SUCCESS;
	DWORD BufSize = *pdwRecvLength;

	if (dwSendLength <= 5)
	{
		*pdwRecvLength = 0;
		Status = SCARD_E_INVALID_PARAMETER;
	}
	else if (dwSendLength > 255)
	{
		*pdwRecvLength = 0;
		Status = SCARD_E_INVALID_PARAMETER;
	}
	else if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();

		pTr->m_TrBuf.AddByte(0xb6);
		pTr->m_TrBuf.AddBulk((LPBYTE)&dwSendLength, 2);
		pTr->m_TrBuf.AddBulk(pbSendBuffer, dwSendLength);

		Status = pTr->SingleTransceive();

		DWORD Size = pTr->m_RcBuf.GetLength();

		if (Size < 2)  // Length is absent
		{
			*pdwRecvLength = 0;
			if (Status == SCARD_S_SUCCESS)
				Status = SCARD_E_COMM_DATA_LOST;    // 0x8010002F
		}
		else
		{
			Size = 2;
			*pdwRecvLength = 0;
			if (!pTr->m_RcBuf.GetBulk(1, (LPBYTE)pdwRecvLength, &Size))
			{
				*pdwRecvLength = 0;
				if (Status == SCARD_S_SUCCESS)
					Status = SCARD_E_COMM_DATA_LOST;
			}

			if (*pdwRecvLength > BufSize)
			{
				*pdwRecvLength = BufSize;
				if (Status == SCARD_S_SUCCESS)
					Status = SCARD_E_INSUFFICIENT_BUFFER;
			}

			if ((Size = *pdwRecvLength) > 0)
				if (!pTr->m_RcBuf.GetBulk(3, pbRecvBuffer, pdwRecvLength))
				{
					if (Status == SCARD_S_SUCCESS)
						Status = SCARD_E_COMM_DATA_LOST;
				}
		}
	}
	else
	{
		*pdwRecvLength = 0;
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_TDA8029_Command(IN     LPVOID  pReader,
IN     LPCBYTE pbSendBuffer,
IN     DWORD   dwSendLength,
OUT LPBYTE  pbRecvBuffer,
IN OUT LPDWORD pdwRecvLength)
{
	BYTE pbSendBufferEx[256] = { 0 };
	LONG Status = SCARD_S_SUCCESS;
	DWORD BufSize = *pdwRecvLength;

	if (dwSendLength <= 5)
	{
		*pdwRecvLength = 0;
		Status = SCARD_E_INVALID_PARAMETER;
	}
	else if (dwSendLength > 255)
	{
		*pdwRecvLength = 0;
		Status = SCARD_E_INVALID_PARAMETER;
	}
	else if (pReader)
	{
		BYTE LRC = 0;
		for (DWORD i = 0; i < dwSendLength; i++)
			LRC ^= pbSendBuffer[i];
		memcpy(pbSendBufferEx, pbSendBuffer, dwSendLength);
		pbSendBufferEx[dwSendLength++] = LRC;

		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();

		pTr->m_TrBuf.AddByte(0xb6);
		pTr->m_TrBuf.AddBulk((LPBYTE)&dwSendLength, 2);
		pTr->m_TrBuf.AddBulk(pbSendBufferEx, dwSendLength);

		Status = pTr->SingleTransceive();

		DWORD Size = pTr->m_RcBuf.GetLength();

		if (Size < 2)  // Length is absent
		{
			*pdwRecvLength = 0;
			if (Status == SCARD_S_SUCCESS)
				Status = SCARD_E_COMM_DATA_LOST;    // 0x8010002F
		}
		else
		{
			Size = 2;
			*pdwRecvLength = 0;
			if (!pTr->m_RcBuf.GetBulk(1, (LPBYTE)pdwRecvLength, &Size))
			{
				*pdwRecvLength = 0;
				if (Status == SCARD_S_SUCCESS)
					Status = SCARD_E_COMM_DATA_LOST;
			}

			if (*pdwRecvLength > BufSize)
			{
				*pdwRecvLength = BufSize;
				if (Status == SCARD_S_SUCCESS)
					Status = SCARD_E_INSUFFICIENT_BUFFER;
			}

			if ((Size = *pdwRecvLength) > 0)
				if (!pTr->m_RcBuf.GetBulk(3, pbRecvBuffer, pdwRecvLength))
				{
					if (Status == SCARD_S_SUCCESS)
						Status = SCARD_E_COMM_DATA_LOST;
				}
		}
	}
	else
	{
		*pdwRecvLength = 0;
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}
*/

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_TDA8029_Exchange(IN     LPVOID  pReader,
IN		BYTE	ucCommand,
IN     LPCBYTE pbSendBuffer,
IN     DWORD   dwSendLength,
OUT LPBYTE  pbRecvBuffer,
IN OUT LPDWORD pdwRecvLength)
{
	LONG Status = SCARD_S_SUCCESS;
	DWORD BufSize = *pdwRecvLength;

	if (dwSendLength > 255)
	{
		*pdwRecvLength = 0;
		Status = SCARD_E_INVALID_PARAMETER;
	}
	else if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();

		pTr->m_TrBuf.AddByte(0x85);
		pTr->m_TrBuf.AddByte(ucCommand);
		pTr->m_TrBuf.AddBulk((LPBYTE)&dwSendLength, 2);
		pTr->m_TrBuf.AddBulk(pbSendBuffer, dwSendLength);

		Status = pTr->SingleTransceive();

		DWORD Size = pTr->m_RcBuf.GetLength();

		if (Size < 3)  // Length is absent
		{
			*pdwRecvLength = 0;
			if (Status == SCARD_S_SUCCESS)
				Status = SCARD_E_COMM_DATA_LOST;    // 0x8010002F
		}
		else
		{
			Size = 2;
			*pdwRecvLength = 0;
			if (!pTr->m_RcBuf.GetBulk(1, (LPBYTE)pdwRecvLength, &Size))
			{
				*pdwRecvLength = 0;
				if (Status == SCARD_S_SUCCESS)
					Status = SCARD_E_COMM_DATA_LOST;
			}

			if (*pdwRecvLength > BufSize)
			{
				*pdwRecvLength = BufSize;
				if (Status == SCARD_S_SUCCESS)
					Status = SCARD_E_INSUFFICIENT_BUFFER;
			}

			if ((Size = *pdwRecvLength) > 0)
				if (!pTr->m_RcBuf.GetBulk(3, pbRecvBuffer, pdwRecvLength))
				{
					if (Status == SCARD_S_SUCCESS)
						Status = SCARD_E_COMM_DATA_LOST;
				}
		}
	}
	else
	{
		*pdwRecvLength = 0;
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_TDA8029_APDU(IN     LPVOID  pReader,
IN     LPCBYTE pbSendBuffer,
IN     DWORD   dwSendLength,
OUT LPBYTE  pbRecvBuffer,
IN OUT LPDWORD pdwRecvLength)
{
	//60 00 07 00 00 A4 00 00 02 4F 00 8E
	//60 00 02 00 90 00 F2
	LONG Status = SCARD_S_SUCCESS;
	DWORD BufSize = *pdwRecvLength;

	if (dwSendLength == 0)
	{
		*pdwRecvLength = 0;
		Status = SCARD_E_INVALID_PARAMETER;
	}
	else if (dwSendLength > 251)
	{
		*pdwRecvLength = 0;
		Status = SCARD_E_INVALID_PARAMETER;
	}
	else if (pReader)
	{
		Status = CLSCRF_TDA8029_Exchange(pReader, 0x00, pbSendBuffer, dwSendLength, pbRecvBuffer, pdwRecvLength);

		//if (Status == SCARD_F_INTERNAL_ERROR)
		//if (GetLastInternalError(pReader) == 0x80)
		//if (dwExRecvLength == 1)
		//{
		//	CTransfer* pTr = (CTransfer*)pReader;
		//	pTr->m_RcBuf.Clear();
		//	pTr->m_RcBuf.AddByte(pExRecvBuffer[0]);
		//	return SCARD_F_INTERNAL_ERROR;
		//}

		if (Status != SCARD_S_SUCCESS)
			return Status;
	}
	else
	{
		*pdwRecvLength = 0;
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_TDA8029_GetStatus(IN     LPVOID  pReader,
OUT LPBYTE pucStatus)
{
	LONG Status = SCARD_S_SUCCESS;
	const int BUF_SIZE = 256;
	BYTE SendBuffer[BUF_SIZE];
	BYTE RecvBuffer[BUF_SIZE];
	DWORD dwSendLength = 0;
	DWORD dwRecvLength = BUF_SIZE;

	if (pucStatus == 0)
		return SCARD_E_INVALID_PARAMETER;

	Status = CLSCRF_TDA8029_Exchange(pReader, 0xAA, SendBuffer, dwSendLength, RecvBuffer, &dwRecvLength);

	//if (Status != SCARD_S_SUCCESS)
	//	return Status;

	if (dwRecvLength == 0)
	{
		*pucStatus = 0;
		return SCARD_E_COMM_DATA_LOST;    // 0x8010002F
	}

	*pucStatus = RecvBuffer[0];

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_TDA8029_GetATR(IN     LPVOID  pReader,
OUT LPBYTE  pbATRBuffer,
IN OUT LPDWORD pdwATRLength)
{
	LONG Status = SCARD_S_SUCCESS;
	const int BUF_SIZE = 256;
	BYTE SendBuffer[BUF_SIZE];
	//BYTE RecvBuffer[BUF_SIZE];
	DWORD dwSendLength = 0;
	//DWORD dwRecvLength = BUF_SIZE;

	if (pbATRBuffer == 0)
		return SCARD_E_INVALID_PARAMETER;

	if (*pdwATRLength == 0)
		return SCARD_E_INVALID_PARAMETER;

	Status = CLSCRF_TDA8029_Exchange(pReader, 0x69, SendBuffer, dwSendLength, pbATRBuffer, pdwATRLength);

	//if (Status != SCARD_S_SUCCESS)
	//	return Status;

	if (*pdwATRLength == 0)
		return SCARD_E_COMM_DATA_LOST;    // 0x8010002F

	return Status;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_TDA8029_Reset(IN LPVOID pReader,
IN BYTE ucInterval)
{
	LONG Status = SCARD_S_SUCCESS;
	//DWORD dwLen = 1;

	if (pReader)
	{
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte(0x86);
		pTr->m_TrBuf.AddByte(0xba);
		pTr->m_TrBuf.AddByte(ucInterval);

		Status = pTr->SingleTransceive();
	}
	else
	{
		Status = SCARD_E_READER_UNAVAILABLE;
	}

	return Status;
}

//=====================================================================

