#include "StdAfx.h"
#include "crc32.h"

// Note: Due to a certain maximum bit to "1", it spent 
 const unsigned short cnCRC_16 = 0x8005; 
 // CRC-16 = X16 + X15 + X2 + X0 
 const unsigned short cnCRC_CCITT = 0x1021; 
 // CRC-CCITT = X16 + X12 + X5 + X0, said that the 16-bit CRC polynomial is better than the previous 
 //const unsigned long cnCRC_32 = 0x04C10DB7; 
 // CRC-32       = X32 + X26 + X23 + X22 + X16 +       X11 + X10 + X8 + X7 + X5 + X4 + X2 + X1 + X0 
//1 0000 0100 1100 0001 0000 1101 1011 0111                                                                                             
//04C10DB7
// = 1,  , - -   
 //const unsigned long cnCRC_CCITT32 = 0x04C11DB7; 
 //const unsigned long cnCRC_32_1 = 0xEDB88320; 
 //const unsigned long cnCRC_32_2 = 0x82608EDB; 

 /*
 const unsigned long cnCRC_32_3 = 0x1EDC6F41; 
 const unsigned long cnCRC_32_4 = 0x82F63B78; 
 const unsigned long cnCRC_32_5 = 0x8F6E37A0; 
 const unsigned long cnCRC_32_6 = 0x741B8CD7; 
 const unsigned long cnCRC_32_7 = 0xEB31D82E; 
 const unsigned long cnCRC_32_8 = 0xBA0DC66B; 
 const unsigned long cnCRC_32_9 = 0x814141AB; 
 const unsigned long cnCRC_32_10 = 0xD5828281; 
 const unsigned long cnCRC_32_11 = 0xC0A0A0D5; 
 */
  // CRC-CCITT32 = X32 + X26 + X23 + X22 + X16 + X12 + X11 + X10 + X8 + X7 + X5 + X4 + X2 + X1 + X0
//1 0000 0100 1100 0001 0001 1101 1011 0111                                                                                             
//04C11DB7
/*
 unsigned long Table_CRC[256]; // CRC table 
 // construct a 16-bit CRC table 
 void BuildTable16 (unsigned short aPoly) 
 {
 unsigned short i, j; 
 unsigned short nData; 
 unsigned short nAccum; 
 for (i = 0; i <256; i++) 
 {
 nData = (unsigned short ) (i <<8); 
 nAccum = 0; 
 for (j = 0; j <8; j++) 
 {
 if ((nData ^ nAccum) & 0x8000 ) 
 nAccum = (nAccum <<1) ^ aPoly; 
 else 
 nAccum <<= 1; 
 nData <<= 1; 
} 
 Table_CRC [i] = (unsigned long) nAccum; 
} 
} 
 // calculate the value of 16-bit CRC, CRC-16 or CRC-CCITT 
 unsigned short CRC_16 (unsigned char * aData, unsigned long aSize) 
 {
 unsigned long i; 
 unsigned short nAccum = 0x6363; 
 BuildTable16 (cnCRC_CCITT); // or cnCRC_16 
 for (i = 0; i < aSize; nAccum = (nAccum <<8) ^ (unsigned short)Table_CRC[((nAccum>> 8) ^ (*aData))], i++);
 return nAccum; 
}
*/
/*
 // constructor 32-bit CRC table 
 void BuildTable32 (unsigned long aPoly) 
 {
 unsigned long i, j; 
 unsigned long nData; 
 unsigned long nAccum; 
 for (i = 0; i <256; i++) 
 {
 nData = (unsigned long) (i <<24); 
 nAccum = 0; 
 for (j = 0; j <8; j++) 
 {
 if ((nData ^ nAccum) & 0x80000000) 
 nAccum = (nAccum <<1) ^ aPoly; 
 else 
 nAccum <<= 1; 
 nData <<= 1; 
}
 Table_CRC [i] = nAccum; 
} 
} 
*/

 /*
 // calculate the 32-bit CRC-32 value 
 unsigned long CRC_32(unsigned char * aData, unsigned long aSize) 
 {
 unsigned long i; 
 unsigned long nAccum = 0xFFFFFFFF; 
 BuildTable32(cnCRC_CCITT32);//cnCRC_32); 
 for (i = 0; i < aSize; nAccum = (nAccum <<8) ^ Table_CRC [(nAccum>> 24) ^ * aData++], i++);
 return nAccum; 
}
*/
/*
unsigned long getCRC (char *pchBuf, int nBufLen) 
{ 
int i; 
int nIndex; 
char ch; 
unsigned long res; 
unsigned long table [] = {
0x00000000, 0x77073096, 0xEE0E612C, 0x990951BA,
0x076DC419, 0x706AF48F, 0xE963A535, 0x9E6495A3,
0x0EDB8832, 0x79DCB8A4, 0xE0D5E91E, 0x97D2D988,
0x09B64C2B, 0x7EB17CBD, 0xE7B82D07, 0x90BF1D91,

0x1DB71064, 0x6AB020F2, 0xF3B97148, 0x84BE41DE,
0x1ADAD47D, 0x6DDDE4EB, 0xF4D4B551, 0x83D385C7,
0x136C9856, 0x646BA8C0, 0xFD62F97A, 0x8A65C9EC,
0x14015C4F, 0x63066CD9, 0xFA0F3D63, 0x8D080DF5,

0x3B6E20C8, 0x4C69105E, 0xD56041E4, 0xA2677172,
0x3C03E4D1, 0x4B04D447, 0xD20D85FD, 0xA50AB56B,
0x35B5A8FA, 0x42B2986C, 0xDBBBC9D6, 0xACBCF940,
0x32D86CE3, 0x45DF5C75, 0xDCD60DCF, 0xABD13D59,

0x26D930AC, 0x51DE003A, 0xC8D75180, 0xBFD06116,
0x21B4F4B5, 0x56B3C423, 0xCFBA9599, 0xB8BDA50F,
0x2802B89E, 0x5F058808, 0xC60CD9B2, 0xB10BE924,
0x2F6F7C87, 0x58684C11, 0xC1611DAB, 0xB6662D3D,

0x76DC4190, 0x01DB7106, 0x98D220BC, 0xEFD5102A,
0x71B18589, 0x06B6B51F, 0x9FBFE4A5, 0xE8B8D433,
0x7807C9A2, 0x0F00F934, 0x9609A88E, 0xE10E9818,
0x7F6A0DBB, 0x086D3D2D, 0x91646C97, 0xE6635C01,

0x6B6B51F4, 0x1C6C6162, 0x856530D8, 0xF262004E,
0x6C0695ED, 0x1B01A57B, 0x8208F4C1, 0xF50FC457,
0x65B0D9C6, 0x12B7E950, 0x8BBEB8EA, 0xFCB9887C,
0x62DD1DDF, 0x15DA2D49, 0x8CD37CF3, 0xFBD44C65,

0x4DB26158, 0x3AB551CE, 0xA3BC0074, 0xD4BB30E2,
0x4ADFA541, 0x3DD895D7, 0xA4D1C46D, 0xD3D6F4FB,
0x4369E96A, 0x346ED9FC, 0xAD678846, 0xDA60B8D0,
0x44042D73, 0x33031DE5, 0xAA0A4C5F, 0xDD0D7CC9,

0x5005713C, 0x270241AA, 0xBE0B1010, 0xC90C2086,
0x5768B525, 0x206F85B3, 0xB966D409, 0xCE61E49F,
0x5EDEF90E, 0x29D9C998, 0xB0D09822, 0xC7D7A8B4,
0x59B33D17, 0x2EB40D81, 0xB7BD5C3B, 0xC0BA6CAD,

0xEDB88320, 0x9ABFB3B6, 0x03B6E20C, 0x74B1D29A,
0xEAD54739, 0x9DD277AF, 0x04DB2615, 0x73DC1683,
0xE3630B12, 0x94643B84, 0x0D6D6A3E, 0x7A6A5AA8,
0xE40ECF0B, 0x9309FF9D, 0x0A00AE27, 0x7D079EB1,

0xF00F9344, 0x8708A3D2, 0x1E01F268, 0x6906C2FE,
0xF762575D, 0x806567CB, 0x196C3671, 0x6E6B06E7,
0xFED41B76, 0x89D32BE0, 0x10DA7A5A, 0x67DD4ACC,
0xF9B9DF6F, 0x8EBEEFF9, 0x17B7BE43, 0x60B08ED5,

0xD6D6A3E8, 0xA1D1937E, 0x38D8C2C4, 0x4FDFF252,
0xD1BB67F1, 0xA6BC5767, 0x3FB506DD, 0x48B2364B,
0xD80D2BDA, 0xAF0A1B4C, 0x36034AF6, 0x41047A60,
0xDF60EFC3, 0xA867DF55, 0x316E8EEF, 0x4669BE79,

0xCB61B38C, 0xBC66831A, 0x256FD2A0, 0x5268E236,
0xCC0C7795, 0xBB0B4703, 0x220216B9, 0x5505262F,
0xC5BA3BBE, 0xB2BD0B28, 0x2BB45A92, 0x5CB36A04,
0xC2D7FFA7, 0xB5D0CF31, 0x2CD99E8B, 0x5BDEAE1D,

0x9B64C2B0, 0xEC63F226, 0x756AA39C, 0x026D930A,
0x9C0906A9, 0xEB0E363F, 0x72076785, 0x05005713,
0x95BF4A82, 0xE2B87A14, 0x7BB12BAE, 0x0CB61B38,
0x92D28E9B, 0xE5D5BE0D, 0x7CDCEFB7, 0x0BDBDF21,

0x86D3D2D4, 0xF1D4E242, 0x68DDB3F8, 0x1FDA836E,
0x81BE16CD, 0xF6B9265B, 0x6FB077E1, 0x18B74777,
0x88085AE6, 0xFF0F6A70, 0x66063BCA, 0x11010B5C,
0x8F659EFF, 0xF862AE69, 0x616BFFD3, 0x166CCF45,

0xA00AE278, 0xD70DD2EE, 0x4E048354, 0x3903B3C2,
0xA7672661, 0xD06016F7, 0x4969474D, 0x3E6E77DB,
0xAED16A4A, 0xD9D65ADC, 0x40DF0B66, 0x37D83BF0,
0xA9BCAE53, 0xDEBB9EC5, 0x47B2CF7F, 0x30B5FFE9,

0xBDBDF21C, 0xCABAC28A, 0x53B39330, 0x24B4A3A6,
0xBAD03605, 0xCDD70693, 0x54DE5729, 0x23D967BF,
0xB3667A2E, 0xC4614AB8, 0x5D681B02, 0x2A6F2B94,
0xB40BBE37, 0xC30C8EA1, 0x5A05DF1B, 0x2D02EF8D
}; 

res = 0xFFFFFFFF; 
for (i=0;i<nBufLen+4;i++) 
{ 
nIndex = (res >> 24) & 0xFF; 
if (i<nBufLen)
ch = pchBuf[i]; 
else
ch = 0x0; 
res = (res << 8) | ch; 
res ^= table[nIndex]; 
     } 

     return res; 
}
*/




/*
CRC_32::CRC_32()
{
    // This is the official polynomial used by CRC-32 

    // in PKZip, WinZip and Ethernet. 

    ULONG ulPolynomial = 0x04C11DB7;

    // 256 values representing ASCII character codes.

    for(int i = 0; i <= 0xFF; i++)
    {
        Table[i] = Reflect(i, 8) << 24;
        for (int j = 0; j < 8; j++)
            Table[i] = (Table[i] << 1) ^ (Table[i] & (1 << 31) ? ulPolynomial : 0);
        Table[i] = Reflect(Table[i],  32);
    }
}

ULONG CRC_32::Reflect(ULONG ref, char ch)
{
    ULONG value = 0;
    // Swap bit 0 for bit 7

    // bit 1 for bit 6, etc.

    for (int i = 1; i < (ch + 1); i++)
    {
        if (ref & 1)
            value |= 1 << (ch - i);
        ref >>= 1;
    } return value;
}

void CRC_32::Calculate(const LPBYTE buffer, UINT size, ULONG &CRC)
{   // calculate the CRC

    LPBYTE pbyte = buffer;

    while(size--)
        CRC = (CRC >> 8) ^ Table[(CRC & 0xFF) ^ *pbyte++];
}
*/
/*

 // Constructor
crc16::crc16( void ) {
  crc16::init_crc16();
}

// Destructor
crc16::~crc16( void ) {
  // Null
}

// Subs
void crc16::calc_crc16 ( unsigned char byte_in ) {
  int i;
  int temp_crc = 0;
  crc16::byte_count++; //bump the count of bytes that we have processed
                       // so far...
  temp_crc = byte_in * 256;
  crc16::crc_running = temp_crc ^ crc16::crc_running;
  for ( i = 0; i <= 7; i++ ) {
    if ( crc16::crc_running > 32767 ) {
      crc16::crc_running = crc16::crc_running * 2;
      crc16::crc_running = crc16::crc_running ^ POLY16;
    }
    else {
      crc16::crc_running = crc16::crc_running * 2;
    }
    crc16::crc_running &= 0xFFFF;
  }
}

void crc16::init_crc16( void ) {
  crc16::crc_running = 0;
  crc16::byte_count = 0;
}

int crc16::return_crc16( void ) {
  return crc16::crc_running;
}

int crc16::return_byte_count( void ) {
  return crc16::byte_count;
}
*/




unsigned short UpdateCrc(unsigned char ch, unsigned short *lpwCrc)
{
	ch = (ch ^ (unsigned char)((*lpwCrc) & 0x00FF));
	ch = (ch ^ (ch << 4));
	*lpwCrc = (*lpwCrc >> 8) ^ ((unsigned short)ch << 8) ^ ((unsigned short)ch << 3) ^ ((unsigned short)ch >> 4);
	return(*lpwCrc);
}


void ComputeCrc(int CRCType, char *Data, int Length,
BYTE *TransmitFirst, BYTE *TransmitSecond)
{
	unsigned char chBlock;
	unsigned short wCrc;
	switch(CRCType) {
		case CRC_A:
			wCrc = 0x6363; // ITU-V.41 
			break;
		case CRC_B:
			wCrc = 0xFFFF; // ISO/IEC 13239 (formerly ISO/IEC 3309) 
			break;
		default:
		return;
	}
	do {
		chBlock = *Data++;
		UpdateCrc(chBlock, &wCrc);
	} while (--Length);
	if (CRCType == CRC_B)
		wCrc = ~wCrc; // ISO/IEC 13239 (formerly ISO/IEC 3309) 
	*TransmitFirst = (BYTE) (wCrc & 0xFF);
	*TransmitSecond = (BYTE) ((wCrc >> 8) & 0xFF);
	return;
}


/*
void CRC32::Init_CRC32_Table()
{// Called by OnInitDialog()

	// This is the official polynomial used by CRC-32 
	// in PKZip, WinZip and Ethernet. 
	ULONG ulPolynomial = 0x04c11db7;

	// 256 values representing ASCII character codes.
	for(int i = 0; i <= 0xFF; i++)
	{
		crc32_table[i]=Reflect(i, 8) << 24;
		for (int j = 0; j < 8; j++)
			crc32_table[i] = (crc32_table[i] << 1) ^ (crc32_table[i] & (1 << 31) ? ulPolynomial : 0);
		crc32_table[i] = Reflect(crc32_table[i], 32);
	}
}

// Reflection is a requirement for the official CRC-32 standard.
// You can create CRCs without it, but they won't conform to the standard.
ULONG CRC32::Reflect(ULONG ref, char ch)
{// Used only by Init_CRC32_Table()

	ULONG value(0);

	// Swap bit 0 for bit 7
	// bit 1 for bit 6, etc.
	for(int i = 1; i < (ch + 1); i++)
	{
		if(ref & 1)
			value |= 1 << (ch - i);
		ref >>= 1;
	}
	return value;
}


// This function uses the crc32_table lookup table
// to generate a CRC for csData
int CRC32::Get_CRC(unsigned char* buffer, DWORD dwSize)
{
	// Be sure to use unsigned variables,
	// because negative values introduce high bits
	// where zero bits are required.
	ULONG  crc=0;//(0xffffffff);
	int len;

	len = dwSize;
	// Perform the algorithm on each character
	// in the string, using the lookup table values.
	while(len--)
		crc = (crc >> 8) ^ crc32_table[(crc & 0xFF) ^ *buffer++];
	// Exclusive OR the result with the beginning value.
	return crc^0xffffffff;
}
*/


//=====================================================
bool    CRC32::mTableBuilt = false;
u32     CRC32::mTable[0x100];

//=====================================================

void CRC32::BuildTable()
{
    int i, j;
    for(i = 0; i < 0x100; ++i)
    {
        mTable[i] = Reflect(static_cast<u32>(i),8) << 24;

        for(j = 0; j < 8; ++j)
            mTable[i] = (mTable[i] << 1) ^ ( (mTable[i] & (1<<31))  ? POLYNOMIAL : 0);

        mTable[i] = Reflect(mTable[i],32);
    }
    mTableBuilt = true;
}

u32 CRC32::Reflect(u32 v,int bits)
{
    u32 ret = 0;
    int i;

    --bits;
    for(i = 0; i <= bits; ++i)
    {
        if(v & (1<<i))
            ret |= 1 << (bits-i);
    }
    return ret;
}

//=====================================================

void CRC32::Hash(const void* buf,uint_t siz)
{
    //=============================
    const u8* p = reinterpret_cast<const u8*>(buf);

    //=============================
    if(!mTableBuilt)
        BuildTable();

    uint_t i;
    for(i = 0; i < siz; ++i)
        mCrc = (mCrc >> 8) ^ mTable[ (mCrc & 0xFF) ^ p[i] ];
}
